///////////////////////////////////////////////////////////////////////////////
//$Date: 2010/06/25 15:58:01 $
//$RCSfile: example_mgt_top_ces4.ejava,v $
//$Revision: 1.4 $
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.7
//  \   \         Application : RocketIO Wizard 
//  /   /         Filename : example_mgt_top.v
// /___/   /\     Timestamp : 
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module EXAMPLE_MGT_TOP
// Generated by Xilinx RocketIO Wizard

//  ***************************************************************************
// (c) Copyright 2006 - 2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.

//  ***************************************************************************

`timescale 1ns / 1ps
`define DLY #1


//***********************************Entity Declaration************************

module EXAMPLE_MGT_TOP #
(
    parameter USE_CHIPSCOPE           =   1,    // Set to 1 to use Chipscope to drive resets
    parameter SIMULATION_P            =   0     // Set to 1 when using module in simulation
)
(
    UPPER_MGTCLK_PAD_N_IN,
    UPPER_MGTCLK_PAD_P_IN,
    DRP_CLK_IN,
    TX_SYSTEM_RESET_IN,
    RX_SYSTEM_RESET_IN,
    MGT0_RXLOCK_OUT,
    MGT0_TXLOCK_OUT,
    MGT1_RXLOCK_OUT,
    MGT1_TXLOCK_OUT,
    RX1N_IN,
    RX1P_IN,
    TX1N_OUT,
    TX1P_OUT
);

// synthesis attribute X_CORE_INFO of EXAMPLE_MGT_TOP is "v4fx_mgtwizard_v1_7, Coregen v12.1";

//***********************************Port Declaration*******************************

    input               UPPER_MGTCLK_PAD_N_IN;
    input               UPPER_MGTCLK_PAD_P_IN;
    input               DRP_CLK_IN;
    input               TX_SYSTEM_RESET_IN;
    input               RX_SYSTEM_RESET_IN;
    output              MGT0_RXLOCK_OUT;
    output              MGT0_TXLOCK_OUT;
    output              MGT1_RXLOCK_OUT;
    output              MGT1_TXLOCK_OUT;
    input    [1:0]      RX1N_IN;
    input    [1:0]      RX1P_IN;
    output   [1:0]      TX1N_OUT;
    output   [1:0]      TX1P_OUT;



    
//************************** Register Declarations ****************************        

    reg     [0:3]      debounce_rx_system_reset_r;
    reg     [0:3]      debounce_tx_system_reset_r;
    reg     [0:3]      extend_rxreset_c;
    reg     [0:3]      extend_txreset_c;
    reg     [7:0]      vio_error_count_i;
    reg                vio_rxusrlogic_reset_i;
    reg                vio_rxbufferr_i;
    reg                vio_rxlock_i;
    reg                vio_rxreset_i;
    reg     [31:0]     vio_txdata_i;
    reg                vio_txusrlogic_reset_i;
    reg                vio_txbufferr_i;
    reg                vio_txlock_i;
    reg                vio_txreset_i;
    
//**************************** Wire Declarations ******************************

    //---------------------- Reference Clock Wires ----------------------------
    wire                refclk1_i;

    //------------------------ MGT Wrapper Wires ------------------------------
    //________________________________________________________________________
    //________________________________________________________________________
    //MGT0   (X1Y2)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    wire    [3:0]       mgt0_rxchariscomma_i;
    wire    [3:0]       mgt0_rxcharisk_i;
    wire    [31:0]      mgt0_rxdata_i;
    wire    [3:0]       mgt0_rxdisperr_i;
    wire    [3:0]       mgt0_rxnotintable_i;
    wire    [3:0]       mgt0_rxrundisp_i;
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    wire    [3:0]       mgt0_txbypass8b10b_i;
    wire    [3:0]       mgt0_txchardispmode_i;
    wire    [3:0]       mgt0_txchardispval_i;
    wire    [3:0]       mgt0_txcharisk_i;
    wire    [31:0]      mgt0_txdata_i;
    wire    [3:0]       mgt0_txkerr_i;
    wire    [3:0]       mgt0_txrundisp_i;
    //------------------------ Calibration Block Ports -------------------------
    wire                mgt0_active_i;
    wire                mgt0_disable_i;
    wire                mgt0_drp_reset_i;
    wire                mgt0_rx_signal_detect_i;
    wire                mgt0_tx_signal_detect_i;
    //--------------------------- Calibration Ports ----------------------------
    wire                mgt0_rxclkstable_i;
    wire                mgt0_txclkstable_i;
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    wire    [7:0]       mgt0_daddr_i;
    wire                mgt0_dclk_i;
    wire                mgt0_den_i;
    wire    [15:0]      mgt0_di_i;
    wire    [15:0]      mgt0_do_i;
    wire                mgt0_drdy_i;
    wire                mgt0_dwe_i;
    //------------------------------ Global Ports ------------------------------
    wire    [1:0]       mgt0_loopback_i;
    wire                mgt0_powerdown_i;
    wire                mgt0_txinhibit_i;
    //---------------------- Out of Band Signalling Ports ----------------------
    wire                mgt0_rxsigdet_i;
    wire                mgt0_txenoob_i;
    //-------------------------------- PLL Lock --------------------------------
    wire                mgt0_rxlock_i;
    wire                mgt0_txlock_i;
    //------------------------- Polarity Control Ports -------------------------
    wire                mgt0_rxpolarity_i;
    wire                mgt0_txpolarity_i;
    //--------------------------------- Resets ---------------------------------
    wire                mgt0_rxpmareset_i;
    wire                mgt0_rxreset_i;
    wire                mgt0_txpmareset_i;
    wire                mgt0_txreset_i;
    //---------------------------- Serdes Alignment ----------------------------
    wire                mgt0_enmcommaalign_i;
    wire                mgt0_enpcommaalign_i;
    wire                mgt0_rxcommadet_i;
    wire                mgt0_rxrealign_i;
    //------------------------------ Serial Ports ------------------------------
    wire                mgt0_rx1n_i;
    wire                mgt0_rx1p_i;
    wire                mgt0_tx1n_i;
    wire                mgt0_tx1p_i;
    //--------------------------------- Status ---------------------------------
    wire    [5:0]       mgt0_rxstatus_i;
    //---------------------------- Synchronization -----------------------------
    wire                mgt0_rxsync_i;
    wire                mgt0_txsync_i;
    //------------------------------ User Clocks -------------------------------
    wire                mgt0_rxrecclk1_i;
    wire                mgt0_rxrecclk2_i;
    wire                mgt0_rxusrclk2_i;
    wire                mgt0_txoutclk1_i;
    wire                mgt0_txoutclk2_i;
    wire                mgt0_txusrclk2_i;
    //----------------------------- Error Counter ------------------------------
    wire     [7:0]      mgt0_error_count_i;                           
    //________________________________________________________________________
    //________________________________________________________________________
    //MGT1   (X1Y3)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    wire    [3:0]       mgt1_rxchariscomma_i;
    wire    [3:0]       mgt1_rxcharisk_i;
    wire    [31:0]      mgt1_rxdata_i;
    wire    [3:0]       mgt1_rxdisperr_i;
    wire    [3:0]       mgt1_rxnotintable_i;
    wire    [3:0]       mgt1_rxrundisp_i;
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    wire    [3:0]       mgt1_txbypass8b10b_i;
    wire    [3:0]       mgt1_txchardispmode_i;
    wire    [3:0]       mgt1_txchardispval_i;
    wire    [3:0]       mgt1_txcharisk_i;
    wire    [31:0]      mgt1_txdata_i;
    wire    [3:0]       mgt1_txkerr_i;
    wire    [3:0]       mgt1_txrundisp_i;
    //------------------------ Calibration Block Ports -------------------------
    wire                mgt1_active_i;
    wire                mgt1_disable_i;
    wire                mgt1_drp_reset_i;
    wire                mgt1_rx_signal_detect_i;
    wire                mgt1_tx_signal_detect_i;
    //--------------------------- Calibration Ports ----------------------------
    wire                mgt1_rxclkstable_i;
    wire                mgt1_txclkstable_i;
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    wire    [7:0]       mgt1_daddr_i;
    wire                mgt1_dclk_i;
    wire                mgt1_den_i;
    wire    [15:0]      mgt1_di_i;
    wire    [15:0]      mgt1_do_i;
    wire                mgt1_drdy_i;
    wire                mgt1_dwe_i;
    //------------------------------ Global Ports ------------------------------
    wire    [1:0]       mgt1_loopback_i;
    wire                mgt1_powerdown_i;
    wire                mgt1_txinhibit_i;
    //---------------------- Out of Band Signalling Ports ----------------------
    wire                mgt1_rxsigdet_i;
    wire                mgt1_txenoob_i;
    //-------------------------------- PLL Lock --------------------------------
    wire                mgt1_rxlock_i;
    wire                mgt1_txlock_i;
    //------------------------- Polarity Control Ports -------------------------
    wire                mgt1_rxpolarity_i;
    wire                mgt1_txpolarity_i;
    //--------------------------------- Resets ---------------------------------
    wire                mgt1_rxpmareset_i;
    wire                mgt1_rxreset_i;
    wire                mgt1_txpmareset_i;
    wire                mgt1_txreset_i;
    //---------------------------- Serdes Alignment ----------------------------
    wire                mgt1_enmcommaalign_i;
    wire                mgt1_enpcommaalign_i;
    wire                mgt1_rxcommadet_i;
    wire                mgt1_rxrealign_i;
    //------------------------------ Serial Ports ------------------------------
    wire                mgt1_rx1n_i;
    wire                mgt1_rx1p_i;
    wire                mgt1_tx1n_i;
    wire                mgt1_tx1p_i;
    //--------------------------------- Status ---------------------------------
    wire    [5:0]       mgt1_rxstatus_i;
    //---------------------------- Synchronization -----------------------------
    wire                mgt1_rxsync_i;
    wire                mgt1_txsync_i;
    //------------------------------ User Clocks -------------------------------
    wire                mgt1_rxrecclk1_i;
    wire                mgt1_rxrecclk2_i;
    wire                mgt1_rxusrclk2_i;
    wire                mgt1_txoutclk1_i;
    wire                mgt1_txoutclk2_i;
    wire                mgt1_txusrclk2_i;
    //----------------------------- Error Counter ------------------------------
    wire     [7:0]      mgt1_error_count_i;                           

    //------------------------- Unused MGT  Wires ------------------------------


    //----------------------------- Global Signals -----------------------------

    wire                dcm_locked_i;
    wire                dcm_reset_i;
    wire                reset_till_txlock_i;
    wire                rxbuferr_i;
    wire                rx_lock_i;
    wire                rx_pmareset_c;
    wire                rx_system_reset_in_i;
    wire                rx_post_sync_reset_i;
    wire                rxreset_c;
    wire                rxreset_i;
    wire                rx_system_ready_i;
    wire                rx_system_reset_c;
    wire     [31:0]     rx_d_i;
    wire                rx_sync_complete_i;
    wire                txbuferr_i;
    wire     [31:0]     tx_d_i;
    wire                rx_usrclks_stable_i;
    wire                rx_user_logic_reset_c;
    wire                tx_pmareset_c;
    wire                tx_pmareset_in_i;
    wire                tx_post_sync_reset_i;
    wire                txreset_c;
    wire                txreset_i;
    wire                tx_system_reset_c;
    wire                tx_system_reset_in_i;
    wire                tx_sync_complete_i;
    wire                usr_clk_i;
    wire                usr_clk2_i;
    wire                txoutclk_i;
    wire                tied_to_ground_i;
    wire     [63:0]     tied_to_ground_vec_i;
    wire                tied_to_vcc_i;
    wire     [7:0]      tied_to_vcc_vec_i;
    wire                tx_lock_i;
    wire                tx_sync_i;
    wire                tx_system_ready_i;
    wire                tx_usrclks_stable_i;
    wire                tx_user_logic_reset_c;
    wire                drp_clk_in_i;

    //------------------------------ Combus signals ----------------------------

    
    wire    [15:0]      tile1_combusout_a_i;
    wire    [15:0]      tile1_combusout_b_i;
    
    
    
    
    

    //--------------------------- Chipscope Signals ----------------------------
    wire     [35:0]     data_vio_control_i;
    wire     [79:0]     data_vio_in_i;
    wire     [9:0]      data_vio_out_i;
    wire     [1:0]      mux_sel;
    wire     [35:0]     reset_vio_control_i;
    wire     [1:0]      reset_vio_out_i;

//**************************** Main Body of Code *******************************

    //  Static signal Assigments    
    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 8'hff;


    
    //Buffer the DRP Clock
    BUFG drp_clk_in_bufg_i
    (
        .I      (DRP_CLK_IN),
        .O      (drp_clk_in_i)
    );

    
    // Extend the TX_SYSTEM_RESET_IN signal using the DRP_CLK
    always @(posedge drp_clk_in_i)
        debounce_tx_system_reset_r <=  {tx_system_reset_in_i,debounce_tx_system_reset_r[0:2]};
        
    assign  tx_system_reset_c  =   |debounce_tx_system_reset_r;


    // Extend the RX_SYSTEM_RESET_IN signal using the DRP_CLK
    always @(posedge drp_clk_in_i)
        debounce_rx_system_reset_r <=  {rx_system_reset_in_i,debounce_rx_system_reset_r[0:2]};
        
    assign  rx_system_reset_c  =   |debounce_rx_system_reset_r;


    // AND all the txlock signals together as an input to the GT11_INIT module
    assign          txlock_i =        MGT0_TXLOCK_OUT &
                                      MGT1_TXLOCK_OUT ;

    assign          txbuferr_i  =     tied_to_ground_i;


    // AND all the rxlock signals together as an input to the GT11_INIT module
    assign          rxlock_i  =       MGT0_RXLOCK_OUT &
                                      MGT1_RXLOCK_OUT ;

    assign          rxbuferr_i  =     tied_to_ground_i;

    // tx_user_logic_reset_c signal for resetting the tx user logic
    assign          tx_user_logic_reset_c =   ~tx_system_ready_i;
    assign          tx_usrclks_stable_i   =   tied_to_vcc_i;


    // rx_user_logic_reset_c signal for resetting the rx user logic
    assign          rx_user_logic_reset_c =  ~rx_system_ready_i;
    assign          rx_usrclks_stable_i   =   tied_to_vcc_i;

    //--------------------- Instantiate an MGTCLK module  ---------------------
    
    MGT_CLOCK_MODULE mgt_clock_module_i
    (
        //----------------- Input Differential Clocks from Pads ---------------
        .UPPER_MGTCLK_PAD_N_IN          (UPPER_MGTCLK_PAD_N_IN),
        .UPPER_MGTCLK_PAD_P_IN          (UPPER_MGTCLK_PAD_P_IN),
        //----------------------- Output Reference Clocks ---------------------
        .REFCLK1_OUT                    (refclk1_i)
    
    );





    //--------------------- Instantiate an GT11_INIT module -------------------
    // This module is responsible for performing the correct reset and lock procedure 
    // as recommended in the user guide

    GT11_INIT_TX #
    (
        .C_SIMULATION (SIMULATION_P)
    )
    gt11_init_tx_i 
    (
        .CLK          (drp_clk_in_i),   
        .START_INIT   (tx_system_reset_in_i),      
        .USRCLK_STABLE(tx_usrclks_stable_i),
        .LOCK         (txlock_i),    
        .PCS_ERROR    (txbuferr_i),    
        .PMA_RESET    (tx_pmareset_c),  
        .PCS_RESET    (txreset_c),          
        .SYNC         (tx_sync_i),
        .READY        (tx_system_ready_i)   
    );
    

    GT11_INIT_RX #
    (
        .C_SIMULATION (SIMULATION_P)
    )
    gt11_init_rx_i 
    (
        .CLK          (drp_clk_in_i),  
        .START_INIT   (rx_system_reset_in_i),  
        .USRCLK_STABLE(rx_usrclks_stable_i),
        .LOCK         (rxlock_i),   
        .PCS_ERROR    (rxbuferr_i),   
        .PMA_RESET    (rx_pmareset_c), 
        .PCS_RESET    (rxreset_c),         
        .SYNC         (rx_sync_i),
        .READY        (rx_system_ready_i)  
    );

    //-------------------- Instantiate MGT Wrapper ----------------------------   

    defparam rocketio_i.SIMULATION_P = SIMULATION_P;
    defparam rocketio_i.MGT0_GT11_MODE_P  = "B";
    defparam rocketio_i.MGT0_MGT_ID_P     = 1;
    defparam rocketio_i.MGT1_GT11_MODE_P  = "A";
    defparam rocketio_i.MGT1_MGT_ID_P     = 0;
    ROCKETIO rocketio_i
    (
        //_____________________________________________________________________
        //_____________________________________________________________________
        //MGT0   (X1Y2)
        //--------------- 8B10B Receive Data Path and Control Ports ----------------
        .MGT0_RXCHARISCOMMA_OUT         (mgt0_rxchariscomma_i),
        .MGT0_RXCHARISK_OUT             (mgt0_rxcharisk_i),
        .MGT0_RXDATA_OUT                (mgt0_rxdata_i),
        .MGT0_RXDISPERR_OUT             (mgt0_rxdisperr_i),
        .MGT0_RXNOTINTABLE_OUT          (mgt0_rxnotintable_i),
        .MGT0_RXRUNDISP_OUT             (mgt0_rxrundisp_i),
        //--------------- 8B10B Transmit Data Path and Control Ports ---------------
        .MGT0_TXBYPASS8B10B_IN          (tied_to_ground_vec_i[3:0]),
        .MGT0_TXCHARDISPMODE_IN         (tied_to_ground_vec_i[3:0]),
        .MGT0_TXCHARDISPVAL_IN          (tied_to_ground_vec_i[3:0]),
        .MGT0_TXCHARISK_IN              (mgt0_txcharisk_i),
        .MGT0_TXDATA_IN                 (mgt0_txdata_i),
        .MGT0_TXKERR_OUT                (mgt0_txkerr_i),
        .MGT0_TXRUNDISP_OUT             (mgt0_txrundisp_i),
        //------------------------ Calibration Block Ports -------------------------
        .MGT0_ACTIVE_OUT                (mgt0_active_i),
        .MGT0_DISABLE_IN                (tied_to_ground_i),
        .MGT0_DRP_RESET_IN              (tx_system_reset_in_i | rx_system_reset_in_i),
        .MGT0_RX_SIGNAL_DETECT_IN       (tied_to_vcc_i),
        .MGT0_TX_SIGNAL_DETECT_IN       (tied_to_vcc_i),
        //--------------------------- Calibration Ports ----------------------------
        .MGT0_RXCLKSTABLE_IN            (tied_to_vcc_i),
        .MGT0_TXCLKSTABLE_IN            (tied_to_vcc_i),
        //------------------- Dynamic Reconfiguration Port (DRP) -------------------
        .MGT0_DADDR_IN                  (tied_to_ground_vec_i[7:0]),
        .MGT0_DCLK_IN                   (drp_clk_in_i),
        .MGT0_DEN_IN                    (tied_to_ground_i),
        .MGT0_DI_IN                     (tied_to_ground_vec_i[15:0]),
        .MGT0_DO_OUT                    (),
        .MGT0_DRDY_OUT                  (),
        .MGT0_DWE_IN                    (tied_to_ground_i),
        //------------------------------ Global Ports ------------------------------
        .MGT0_LOOPBACK_IN               (tied_to_ground_vec_i[1:0]),
        .MGT0_POWERDOWN_IN              (tied_to_ground_i),
        .MGT0_TXINHIBIT_IN              (tied_to_ground_i),
        //---------------------- Out of Band Signalling Ports ----------------------
        .MGT0_RXSIGDET_OUT              (mgt0_rxsigdet_i),
        .MGT0_TXENOOB_IN                (tied_to_ground_i),
        //-------------------------------- PLL Lock --------------------------------
        .MGT0_RXLOCK_OUT                (MGT0_RXLOCK_OUT),
        .MGT0_TXLOCK_OUT                (MGT0_TXLOCK_OUT),
        //------------------------- Polarity Control Ports -------------------------
        .MGT0_RXPOLARITY_IN             (tied_to_ground_i),
        .MGT0_TXPOLARITY_IN             (tied_to_ground_i),
        //-------------------------- Ports for Simulation --------------------------
        .MGT0_COMBUSIN_IN               (tile1_combusout_a_i),
        .MGT0_COMBUSOUT_OUT             (tile1_combusout_b_i),
        //---------------------------- Reference Clocks ----------------------------
        .MGT0_REFCLK1_IN                (refclk1_i),
        //--------------------------------- Resets ---------------------------------
        .MGT0_RXPMARESET_IN             (rx_pmareset_c),
        .MGT0_RXRESET_IN                (rxreset_c),
        .MGT0_TXPMARESET_IN             (tx_pmareset_c),
        .MGT0_TXRESET_IN                (txreset_c),
        //---------------------------- Serdes Alignment ----------------------------
        .MGT0_ENMCOMMAALIGN_IN          (mgt0_enmcommaalign_i),
        .MGT0_ENPCOMMAALIGN_IN          (mgt0_enpcommaalign_i),
        .MGT0_RXCOMMADET_OUT            (mgt0_rxcommadet_i),
        .MGT0_RXREALIGN_OUT             (mgt0_rxrealign_i),
        //------------------------------ Serial Ports ------------------------------
        .MGT0_RX1N_IN                   (RX1N_IN[0]),
        .MGT0_RX1P_IN                   (RX1P_IN[0]),
        .MGT0_TX1N_OUT                  (TX1N_OUT[0]),
        .MGT0_TX1P_OUT                  (TX1P_OUT[0]),
        //--------------------------------- Status ---------------------------------
        .MGT0_RXSTATUS_OUT              (mgt0_rxstatus_i),
        //---------------------------- Synchronization -----------------------------
        .MGT0_RXSYNC_IN                 (rx_sync_i),
        .MGT0_TXSYNC_IN                 (tx_sync_i),
        //------------------------------ User Clocks -------------------------------
        .MGT0_RXRECCLK1_OUT             (mgt0_rxrecclk1_i),
        .MGT0_RXRECCLK2_OUT             (mgt0_rxrecclk2_i),
        .MGT0_RXUSRCLK2_IN              (usr_clk2_i),
        .MGT0_TXOUTCLK1_OUT             (mgt0_txoutclk1_i),
        .MGT0_TXOUTCLK2_OUT             (mgt0_txoutclk2_i),
        .MGT0_TXUSRCLK2_IN              (usr_clk2_i),

        //_____________________________________________________________________
        //_____________________________________________________________________
        //MGT1   (X1Y3)
        //--------------- 8B10B Receive Data Path and Control Ports ----------------
        .MGT1_RXCHARISCOMMA_OUT         (mgt1_rxchariscomma_i),
        .MGT1_RXCHARISK_OUT             (mgt1_rxcharisk_i),
        .MGT1_RXDATA_OUT                (mgt1_rxdata_i),
        .MGT1_RXDISPERR_OUT             (mgt1_rxdisperr_i),
        .MGT1_RXNOTINTABLE_OUT          (mgt1_rxnotintable_i),
        .MGT1_RXRUNDISP_OUT             (mgt1_rxrundisp_i),
        //--------------- 8B10B Transmit Data Path and Control Ports ---------------
        .MGT1_TXBYPASS8B10B_IN          (tied_to_ground_vec_i[3:0]),
        .MGT1_TXCHARDISPMODE_IN         (tied_to_ground_vec_i[3:0]),
        .MGT1_TXCHARDISPVAL_IN          (tied_to_ground_vec_i[3:0]),
        .MGT1_TXCHARISK_IN              (mgt1_txcharisk_i),
        .MGT1_TXDATA_IN                 (mgt1_txdata_i),
        .MGT1_TXKERR_OUT                (mgt1_txkerr_i),
        .MGT1_TXRUNDISP_OUT             (mgt1_txrundisp_i),
        //------------------------ Calibration Block Ports -------------------------
        .MGT1_ACTIVE_OUT                (mgt1_active_i),
        .MGT1_DISABLE_IN                (tied_to_ground_i),
        .MGT1_DRP_RESET_IN              (tx_system_reset_in_i | rx_system_reset_in_i),
        .MGT1_RX_SIGNAL_DETECT_IN       (tied_to_vcc_i),
        .MGT1_TX_SIGNAL_DETECT_IN       (tied_to_vcc_i),
        //--------------------------- Calibration Ports ----------------------------
        .MGT1_RXCLKSTABLE_IN            (tied_to_vcc_i),
        .MGT1_TXCLKSTABLE_IN            (tied_to_vcc_i),
        //------------------- Dynamic Reconfiguration Port (DRP) -------------------
        .MGT1_DADDR_IN                  (tied_to_ground_vec_i[7:0]),
        .MGT1_DCLK_IN                   (drp_clk_in_i),
        .MGT1_DEN_IN                    (tied_to_ground_i),
        .MGT1_DI_IN                     (tied_to_ground_vec_i[15:0]),
        .MGT1_DO_OUT                    (),
        .MGT1_DRDY_OUT                  (),
        .MGT1_DWE_IN                    (tied_to_ground_i),
        //------------------------------ Global Ports ------------------------------
        .MGT1_LOOPBACK_IN               (tied_to_ground_vec_i[1:0]),
        .MGT1_POWERDOWN_IN              (tied_to_ground_i),
        .MGT1_TXINHIBIT_IN              (tied_to_ground_i),
        //---------------------- Out of Band Signalling Ports ----------------------
        .MGT1_RXSIGDET_OUT              (mgt1_rxsigdet_i),
        .MGT1_TXENOOB_IN                (tied_to_ground_i),
        //-------------------------------- PLL Lock --------------------------------
        .MGT1_RXLOCK_OUT                (MGT1_RXLOCK_OUT),
        .MGT1_TXLOCK_OUT                (MGT1_TXLOCK_OUT),
        //------------------------- Polarity Control Ports -------------------------
        .MGT1_RXPOLARITY_IN             (tied_to_ground_i),
        .MGT1_TXPOLARITY_IN             (tied_to_ground_i),
        //-------------------------- Ports for Simulation --------------------------
        .MGT1_COMBUSIN_IN               (tile1_combusout_b_i),
        .MGT1_COMBUSOUT_OUT             (tile1_combusout_a_i),
        //---------------------------- Reference Clocks ----------------------------
        .MGT1_REFCLK1_IN                (refclk1_i),
        //--------------------------------- Resets ---------------------------------
        .MGT1_RXPMARESET_IN             (rx_pmareset_c),
        .MGT1_RXRESET_IN                (rxreset_c),
        .MGT1_TXPMARESET_IN             (tx_pmareset_c),
        .MGT1_TXRESET_IN                (txreset_c),
        //---------------------------- Serdes Alignment ----------------------------
        .MGT1_ENMCOMMAALIGN_IN          (mgt1_enmcommaalign_i),
        .MGT1_ENPCOMMAALIGN_IN          (mgt1_enpcommaalign_i),
        .MGT1_RXCOMMADET_OUT            (mgt1_rxcommadet_i),
        .MGT1_RXREALIGN_OUT             (mgt1_rxrealign_i),
        //------------------------------ Serial Ports ------------------------------
        .MGT1_RX1N_IN                   (RX1N_IN[1]),
        .MGT1_RX1P_IN                   (RX1P_IN[1]),
        .MGT1_TX1N_OUT                  (TX1N_OUT[1]),
        .MGT1_TX1P_OUT                  (TX1P_OUT[1]),
        //--------------------------------- Status ---------------------------------
        .MGT1_RXSTATUS_OUT              (mgt1_rxstatus_i),
        //---------------------------- Synchronization -----------------------------
        .MGT1_RXSYNC_IN                 (rx_sync_i),
        .MGT1_TXSYNC_IN                 (tx_sync_i),
        //------------------------------ User Clocks -------------------------------
        .MGT1_RXRECCLK1_OUT             (mgt1_rxrecclk1_i),
        .MGT1_RXRECCLK2_OUT             (mgt1_rxrecclk2_i),
        .MGT1_RXUSRCLK2_IN              (usr_clk2_i),
        .MGT1_TXOUTCLK1_OUT             (mgt1_txoutclk1_i),
        .MGT1_TXOUTCLK2_OUT             (mgt1_txoutclk2_i),
        .MGT1_TXUSRCLK2_IN              (usr_clk2_i)

  );
    



    
    //-------------Bufg used to drive user clk on global clock net ------------
    // Bufg used to drive user clk on global clock net.
    BUFG  user_clock_bufg_i
    (
        //.I                              (mgt1_txoutclk1_i),
                   .I                   (mgt1_rxrecclk1_i),
        
        .O                              (usr_clk2_i)
    );
    

    //----------- Instantiate the frame generator for data generation ---------

    FRAME_GEN mgt0_frame_gen_i
    (
        // User Interface
        .TX_DATA                        (mgt0_txdata_i),  
        .TX_CHARISK                     (mgt0_txcharisk_i),
        .TX_ENMCOMMA_ALIGN              (mgt0_enmcommaalign_i),
        .TX_ENPCOMMA_ALIGN              (mgt0_enpcommaalign_i),
        // System Interface
        .USER_CLK                       (usr_clk2_i),       
        .RESET                          (tx_user_logic_reset_c)
    ); 
    FRAME_GEN mgt1_frame_gen_i
    (
        // User Interface
        .TX_DATA                        (mgt1_txdata_i),  
        .TX_CHARISK                     (mgt1_txcharisk_i),
        .TX_ENMCOMMA_ALIGN              (mgt1_enmcommaalign_i),
        .TX_ENPCOMMA_ALIGN              (mgt1_enpcommaalign_i),
        // System Interface
        .USER_CLK                       (usr_clk2_i),       
        .RESET                          (tx_user_logic_reset_c)
    ); 


    //------------ Instantiate the frame generator for data checking ---------- 

    FRAME_CHECK mgt0_frame_check_i
    (
        // User Interface
        .RX_DATA                        (mgt0_rxdata_i),  
        // System Interface
        .USER_CLK                       (usr_clk2_i),       
        .RESET                          (rx_user_logic_reset_c),
        .ERROR_COUNT                    (mgt0_error_count_i)
  
    );
    FRAME_CHECK mgt1_frame_check_i
    (
        // User Interface
        .RX_DATA                        (mgt1_rxdata_i),  
        // System Interface
        .USER_CLK                       (usr_clk2_i),       
        .RESET                          (rx_user_logic_reset_c),
        .ERROR_COUNT                    (mgt1_error_count_i)
  
    );
    

generate
if (USE_CHIPSCOPE==1) 
begin : chipscope

    // assign the output of the vio to the system resets if chipscope
    // is being used
    assign tx_system_reset_in_i = reset_vio_out_i[0];
    assign rx_system_reset_in_i = reset_vio_out_i[1];
    

// VIO Instantiation and connection to drive the pma reset ports 
    control_vio control_vio_i
    (
      .control                          (reset_vio_control_i),
      .clk                              (drp_clk_in_i),
      .sync_out                         (reset_vio_out_i)
    );
    
  //  ICON core instance 
   icon icon_i
    (
      .control0                         (reset_vio_control_i),
      .control1                         (data_vio_control_i)
    );

  //  VIO core instance for monitoring the mgt ports in hw
    data_vio data_vio_i
    (
      .control                          (data_vio_control_i),
      .clk                              (usr_clk2_i),
      .sync_in                          (data_vio_in_i),
      .sync_out                         (data_vio_out_i)
    );


    // connectthe output vio to the mux signal
    // the probing is done in a muxed fashion where the mux select is
    // one hot encoded i.e. 0001 refers to mgt 1, 0010 refers to mgt 2
    // 0100 refers to mgt3 in a 4 mgt configuration
    assign  mux_sel               =    data_vio_out_i[1:0]; 
    // connect the signals to be probed to the data vio
    assign  data_vio_in_i[0]      =   vio_txreset_i;
    assign  data_vio_in_i[1]      =   vio_rxreset_i;
    assign  data_vio_in_i[2]      =   vio_txlock_i;
    assign  data_vio_in_i[3]      =   vio_rxlock_i;
    assign  data_vio_in_i[4]      =   vio_txbufferr_i;
    assign  data_vio_in_i[5]      =   vio_rxbufferr_i;
    assign  data_vio_in_i[6]      =   vio_txusrlogic_reset_i;
    assign  data_vio_in_i[7]      =   vio_rxusrlogic_reset_i;
    assign  data_vio_in_i[15:8]   =   vio_error_count_i;
    assign  data_vio_in_i[47:16]  =   vio_txdata_i;
    assign  data_vio_in_i[79:48]  =   tied_to_ground_vec_i[31:0];
   
    // muxing logic for the signals to be probed
    always @(posedge usr_clk2_i)
        case(mux_sel)
            2'b01 :
            begin
                vio_txreset_i          <=   txreset_c;
                vio_rxreset_i          <=   rxreset_c;
                vio_txlock_i           <=   MGT0_TXLOCK_OUT;
                vio_rxlock_i           <=   MGT0_RXLOCK_OUT;
                vio_txbufferr_i        <=   tied_to_ground_i;
                vio_rxbufferr_i        <=   tied_to_ground_i;
                vio_txusrlogic_reset_i <=   tx_user_logic_reset_c;
                vio_rxusrlogic_reset_i <=   rx_user_logic_reset_c;
                vio_error_count_i      <=   mgt0_error_count_i;
                vio_txdata_i           <=   mgt0_rxdata_i;
            end
            
            2'b10 :
            begin
                vio_txreset_i          <=   txreset_c;
                vio_rxreset_i          <=   rxreset_c;
                vio_txlock_i           <=   MGT1_TXLOCK_OUT;
                vio_rxlock_i           <=   MGT1_RXLOCK_OUT;
                vio_txbufferr_i        <=   tied_to_ground_i;
                vio_rxbufferr_i        <=   tied_to_ground_i;
                vio_txusrlogic_reset_i <=   tx_user_logic_reset_c;
                vio_rxusrlogic_reset_i <=   rx_user_logic_reset_c;
                vio_error_count_i      <=   mgt1_error_count_i;
                vio_txdata_i           <=   mgt1_rxdata_i;
            end
            
            default:
            begin
                vio_txreset_i          <=   txreset_c;
                vio_rxreset_i          <=   rxreset_c;
                vio_txlock_i           <=   MGT0_TXLOCK_OUT;
                vio_rxlock_i           <=   MGT0_RXLOCK_OUT;
                vio_txbufferr_i        <=   tied_to_ground_i;
                vio_rxbufferr_i        <=   tied_to_ground_i;
                vio_txusrlogic_reset_i <=   tx_user_logic_reset_c;
                vio_rxusrlogic_reset_i <=   rx_user_logic_reset_c;
                vio_error_count_i      <=   mgt0_error_count_i;
                vio_txdata_i           <=   mgt0_rxdata_i;
            end
            
        endcase
end
else 
begin: no_chipscope

    // If Chipscope is not being used, drive the reset signals
    // from the top level ports
    assign tx_system_reset_in_i = TX_SYSTEM_RESET_IN;
    assign rx_system_reset_in_i = RX_SYSTEM_RESET_IN;

end
endgenerate

endmodule


//-------------------------------------------------------------------
//
//  VIO core module declaration 
//  This one is for driving the resets
//
//-------------------------------------------------------------------
module control_vio
  (
    control,
    clk,
    sync_out
  ) /* synthesis syn_black_box syn_noprune=1 */;
  input  [35:0] control;
  input  clk;
  output [1:0] sync_out;
endmodule

//-------------------------------------------------------------------
//
//  ICON core module declaration
//
//-------------------------------------------------------------------
module icon 
  (
      control0,
      control1
  ) /* synthesis syn_black_box syn_noprune=1 */;
  output [35:0] control0;
  output [35:0] control1;
endmodule


//-------------------------------------------------------------------
//
//  VIO core module declaration
//  This one is for monitoring the data
//
//-------------------------------------------------------------------
module data_vio
  (
    control,
    clk,
    sync_in,
    sync_out
  ) /* synthesis syn_black_box syn_noprune=1 */;
  input  [35:0] control;
  input  clk;
  input  [79:0] sync_in;
  output [9:0] sync_out;
endmodule

