
///////////////////////////////////////////////////////////////////////////////
//$Date: 2010/06/25 15:58:01 $
//$RCSfile: frame_gen.ejava,v $
//$Revision: 1.2 $
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.7
//  \   \         Application : RocketIO Wizard 
//  /   /         Filename : frame_gen.v
// /___/   /\     Timestamp : 
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module FRAME_GEN
// Generated by Xilinx RocketIO Wizard
//  ***************************************************************************
// (c) Copyright 2006 - 2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.

//  ***************************************************************************

`timescale 1ns / 1ps
`define DLY #1

//***********************************Entity Declaration*******************************

module FRAME_GEN
(
    // User Interface
    TX_DATA,
    TX_CHARISK,
    TX_ENMCOMMA_ALIGN,
    TX_ENPCOMMA_ALIGN,

    // System Interface
    USER_CLK,       
    RESET
); 

// synthesis attribute X_CORE_INFO of FRAME_GEN is "v4fx_mgtwizard_v1_7, Coregen v12.1";

//***********************************Port Declarations*******************************

   // User Interface
    output  [31:0]     TX_DATA;
    output  [3:0]      TX_CHARISK;
    output             TX_ENMCOMMA_ALIGN;
    output             TX_ENPCOMMA_ALIGN;
    
      // System Interface
    input              USER_CLK;
    input              RESET; 

//********************************* Wire Declarations********************************* 

    wire    [31:0]     align_char_c;    
    wire    [3:0]      control_bits_c;    
    wire    [7:0]      tied_to_ground_vec_i;
    wire    [7:0]      tied_to_ground_i;

//***************************Internal Register Declarations*************************** 

    reg                send_align_r;    
    reg     [3:0]      shift_reg_r;    
    reg                TX_ENMCOMMA_ALIGN;    
    reg                TX_ENPCOMMA_ALIGN;    
    reg     [31:0]     tx_d_r;    
    
//*********************************Main Body of Code**********************************

    assign tied_to_ground_vec_i  =   8'h00;
    assign tied_to_ground_i      =   1'b0;
    
    //______________________________ Transmit Data  __________________________________    

    //Assign TX_DATA to data register or align char based on the value
    assign  TX_DATA             =   (send_align_r) ? align_char_c : tx_d_r;
    assign  TX_CHARISK          =   (send_align_r) ? control_bits_c: tied_to_ground_vec_i[3:0];
    
    //____________________________ Data Generation  __________________________________    

    //Transmit data when send_align_r is de-asserted. Data is right shifted every cycle. 
    always @(posedge USER_CLK)
        if(RESET)               tx_d_r          <=  `DLY    32'd1;
        else if(!send_align_r)  tx_d_r          <=  `DLY    {tx_d_r[0],tx_d_r[31:1]};
    
    //____________________________ Assign the alignment char __________________________    

    assign  align_char_c    =  32'h000000bc; 
    assign  control_bits_c  =  4'b0001;

    always @(posedge USER_CLK)
        if(RESET)  shift_reg_r  <=  `DLY     4'b0001;
        else       shift_reg_r  <=  {shift_reg_r[0],shift_reg_r[3:1]};


    // The send_align_r is driven from a shift register
    // and is used to decide whether the align char or the data is transmitted
    always @(posedge USER_CLK)
        if(RESET)  send_align_r  <=  `DLY     1'b1;
        else       send_align_r  <=  `DLY     shift_reg_r[3];

    // Drive the enamcommaalign port of the mgt for alignment
    always @(posedge USER_CLK)
        if(RESET)  TX_ENMCOMMA_ALIGN   <=  `DLY    1'b0;
        else       TX_ENMCOMMA_ALIGN   <=  `DLY    1'b1;
    // Drive the enapcommaalign port of the mgt for alignment

    always @(posedge USER_CLK)
        if(RESET)  TX_ENPCOMMA_ALIGN   <=  `DLY    1'b0;
        else       TX_ENPCOMMA_ALIGN   <=  `DLY    1'b1;
    
endmodule 

