///////////////////////////////////////////////////////////////////////////////
//
//      Project:  Aurora Module Generator 1.7
//
//         Date:  $Date: 2010/06/25 15:58:02 $
//          Tag:  $Name: i+HEAD+189542 $
//         File:  $RCSfile: mgt_usrclk_source_dcm.ejava,v $
//          Rev:  $Revision: 1.2 $
//
//      Company:  Xilinx
// Contributors:  N. Jayarajan, N. Gulstone
//
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 7.1i
//  \   \         Application : 
//  /   /         Filename : mgt_usrclk_source.v
// /___/   /\     Timestamp : 02/08/2005 09:12:43
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: USRCLK_SOURCE
//
// Module MGT_USRCLK_SOURCE
// Generated by Xilinx Architecture Wizard
// Written for synthesis tool: XST
//  ***************************************************************************
// (c) Copyright 2006 - 2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.

//  ***************************************************************************

`timescale 1ns / 1ps

//***********************************Entity Declaration*******************************

module MGT_USRCLK_SOURCE
(
    USRCLK_SOURCE,  
    USRCLK2_SOURCE,
    DCM_LOCKED,
    TXOUTCLK1_IN,  
    DCM_RESET

);

// synthesis attribute X_CORE_INFO of MGT_USRCLK_SOURCE is "v4fx_mgtwizard_v1_7, Coregen v12.1";

`define DLY #1


//*********************************** Port Declaration *******************************

    output          USRCLK_SOURCE;
    output          USRCLK2_SOURCE;
    output          DCM_LOCKED;
    input           TXOUTCLK1_IN;
    input           DCM_RESET;

//*********************************Wire Declarations**********************************

    wire    [15:0]  not_connected_i;
    wire            clkfb_i;
    wire            clkdv_i;
    wire            clk0_i;

//*********************************** Beginning of Code *******************************
    // Instantiate a DCM module to divide the reference clock.
    DCM  clock_divider_i
    (
        .CLK0(clk0_i),
        .CLK180(not_connected_i[0]),
        .CLK270(not_connected_i[1]),
        .CLK2X(not_connected_i[2]),
        .CLK2X180(not_connected_i[3]),
        .CLK90(not_connected_i[4]),
        .CLKDV(clkdv_i),
        .CLKFX(not_connected_i[5]),
        .CLKFX180(not_connected_i[6]),
        .LOCKED(DCM_LOCKED),
        .PSDONE(not_connected_i[7]),
        .STATUS(not_connected_i[15:8]),
        .CLKFB(clkfb_i),
        .CLKIN(TXOUTCLK1_IN),
        .DSSEN(1'b0),
        .PSCLK(1'b0),
        .PSEN(1'b0),
        .PSINCDEC(1'b0),
        .RST(DCM_RESET)
    );


    defparam clock_divider_i.CLKDV_DIVIDE = 2.0;
    defparam clock_divider_i.DFS_FREQUENCY_MODE = "LOW"; 
    defparam clock_divider_i.DLL_FREQUENCY_MODE = "LOW";


    // BUFG for the feedback clock.  The feedback signal is phase aligned to the input
    // and must come from the CLK0 or CLK2X output of the DCM.  In this case, we use
    // the CLK0 output.
    BUFG feedback_clock_net_i
    (
        .I(clk0_i),
        .O(clkfb_i)
    );


    // The feedback clock is also used to drive the MGT
    BUF  user_clk_2x_buf_i
    (
        .I(clkfb_i),
        .O(USRCLK2_SOURCE)
    );


    // The User Clock is distributed on a global clock net.
    BUFG user_clk_net_i
    (
        .I(clkdv_i),
        .O(USRCLK_SOURCE)
    );



endmodule

