
///////////////////////////////////////////////////////////////////////////////
//$Date: 2010/06/25 15:58:02 $
//$RCSfile: mgt_wrapper.ejava,v $
//$Revision: 1.2 $
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.7
//  \   \         Application : RocketIO Wizard 
//  /   /         Filename : rocketio.v
// /___/   /\     Timestamp : 02/08/2005 09:12:43
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module ROCKETIO (an MGT Wrapper)
// Generated by Xilinx RocketIO Wizard

//  ***************************************************************************
// (c) Copyright 2006 - 2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.

//  ***************************************************************************


`timescale 1ns / 1ps


//***************************** Entity Declaration *****************************
module ROCKETIO
(
    
    //________________________________________________________________________
    //________________________________________________________________________
    //MGT0  (X1Y2)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    MGT0_RXCHARISCOMMA_OUT,
    MGT0_RXCHARISK_OUT,
    MGT0_RXDATA_OUT,
    MGT0_RXDISPERR_OUT,
    MGT0_RXNOTINTABLE_OUT,
    MGT0_RXRUNDISP_OUT,
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    MGT0_TXBYPASS8B10B_IN,
    MGT0_TXCHARDISPMODE_IN,
    MGT0_TXCHARDISPVAL_IN,
    MGT0_TXCHARISK_IN,
    MGT0_TXDATA_IN,
    MGT0_TXKERR_OUT,
    MGT0_TXRUNDISP_OUT,
    //------------------------ Calibration Block Ports -------------------------
    MGT0_ACTIVE_OUT,
    MGT0_DISABLE_IN,
    MGT0_DRP_RESET_IN,
    MGT0_RX_SIGNAL_DETECT_IN,
    MGT0_TX_SIGNAL_DETECT_IN,
    //--------------------------- Calibration Ports ----------------------------
    MGT0_RXCLKSTABLE_IN,
    MGT0_TXCLKSTABLE_IN,
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    MGT0_DADDR_IN,
    MGT0_DCLK_IN,
    MGT0_DEN_IN,
    MGT0_DI_IN,
    MGT0_DO_OUT,
    MGT0_DRDY_OUT,
    MGT0_DWE_IN,
    //------------------------------ Global Ports ------------------------------
    MGT0_LOOPBACK_IN,
    MGT0_POWERDOWN_IN,
    MGT0_TXINHIBIT_IN,
    //---------------------- Out of Band Signalling Ports ----------------------
    MGT0_RXSIGDET_OUT,
    MGT0_TXENOOB_IN,
    //-------------------------------- PLL Lock --------------------------------
    MGT0_RXLOCK_OUT,
    MGT0_TXLOCK_OUT,
    //------------------------- Polarity Control Ports -------------------------
    MGT0_RXPOLARITY_IN,
    MGT0_TXPOLARITY_IN,
    //-------------------------- Ports for Simulation --------------------------
    MGT0_COMBUSIN_IN,
    MGT0_COMBUSOUT_OUT,
    //---------------------------- Reference Clocks ----------------------------
    MGT0_REFCLK1_IN,
    //--------------------------------- Resets ---------------------------------
    MGT0_RXPMARESET_IN,
    MGT0_RXRESET_IN,
    MGT0_TXPMARESET_IN,
    MGT0_TXRESET_IN,
    //---------------------------- Serdes Alignment ----------------------------
    MGT0_ENMCOMMAALIGN_IN,
    MGT0_ENPCOMMAALIGN_IN,
    MGT0_RXCOMMADET_OUT,
    MGT0_RXREALIGN_OUT,
    //------------------------------ Serial Ports ------------------------------
    MGT0_RX1N_IN,
    MGT0_RX1P_IN,
    MGT0_TX1N_OUT,
    MGT0_TX1P_OUT,
    //--------------------------------- Status ---------------------------------
    MGT0_RXSTATUS_OUT,
    //---------------------------- Synchronization -----------------------------
    MGT0_RXSYNC_IN,
    MGT0_TXSYNC_IN,
    //------------------------------ User Clocks -------------------------------
    MGT0_RXRECCLK1_OUT,
    MGT0_RXRECCLK2_OUT,
    MGT0_RXUSRCLK2_IN,
    MGT0_TXOUTCLK1_OUT,
    MGT0_TXOUTCLK2_OUT,
    MGT0_TXUSRCLK2_IN,

    
    //________________________________________________________________________
    //________________________________________________________________________
    //MGT1  (X1Y3)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    MGT1_RXCHARISCOMMA_OUT,
    MGT1_RXCHARISK_OUT,
    MGT1_RXDATA_OUT,
    MGT1_RXDISPERR_OUT,
    MGT1_RXNOTINTABLE_OUT,
    MGT1_RXRUNDISP_OUT,
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    MGT1_TXBYPASS8B10B_IN,
    MGT1_TXCHARDISPMODE_IN,
    MGT1_TXCHARDISPVAL_IN,
    MGT1_TXCHARISK_IN,
    MGT1_TXDATA_IN,
    MGT1_TXKERR_OUT,
    MGT1_TXRUNDISP_OUT,
    //------------------------ Calibration Block Ports -------------------------
    MGT1_ACTIVE_OUT,
    MGT1_DISABLE_IN,
    MGT1_DRP_RESET_IN,
    MGT1_RX_SIGNAL_DETECT_IN,
    MGT1_TX_SIGNAL_DETECT_IN,
    //--------------------------- Calibration Ports ----------------------------
    MGT1_RXCLKSTABLE_IN,
    MGT1_TXCLKSTABLE_IN,
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    MGT1_DADDR_IN,
    MGT1_DCLK_IN,
    MGT1_DEN_IN,
    MGT1_DI_IN,
    MGT1_DO_OUT,
    MGT1_DRDY_OUT,
    MGT1_DWE_IN,
    //------------------------------ Global Ports ------------------------------
    MGT1_LOOPBACK_IN,
    MGT1_POWERDOWN_IN,
    MGT1_TXINHIBIT_IN,
    //---------------------- Out of Band Signalling Ports ----------------------
    MGT1_RXSIGDET_OUT,
    MGT1_TXENOOB_IN,
    //-------------------------------- PLL Lock --------------------------------
    MGT1_RXLOCK_OUT,
    MGT1_TXLOCK_OUT,
    //------------------------- Polarity Control Ports -------------------------
    MGT1_RXPOLARITY_IN,
    MGT1_TXPOLARITY_IN,
    //-------------------------- Ports for Simulation --------------------------
    MGT1_COMBUSIN_IN,
    MGT1_COMBUSOUT_OUT,
    //---------------------------- Reference Clocks ----------------------------
    MGT1_REFCLK1_IN,
    //--------------------------------- Resets ---------------------------------
    MGT1_RXPMARESET_IN,
    MGT1_RXRESET_IN,
    MGT1_TXPMARESET_IN,
    MGT1_TXRESET_IN,
    //---------------------------- Serdes Alignment ----------------------------
    MGT1_ENMCOMMAALIGN_IN,
    MGT1_ENPCOMMAALIGN_IN,
    MGT1_RXCOMMADET_OUT,
    MGT1_RXREALIGN_OUT,
    //------------------------------ Serial Ports ------------------------------
    MGT1_RX1N_IN,
    MGT1_RX1P_IN,
    MGT1_TX1N_OUT,
    MGT1_TX1P_OUT,
    //--------------------------------- Status ---------------------------------
    MGT1_RXSTATUS_OUT,
    //---------------------------- Synchronization -----------------------------
    MGT1_RXSYNC_IN,
    MGT1_TXSYNC_IN,
    //------------------------------ User Clocks -------------------------------
    MGT1_RXRECCLK1_OUT,
    MGT1_RXRECCLK2_OUT,
    MGT1_RXUSRCLK2_IN,
    MGT1_TXOUTCLK1_OUT,
    MGT1_TXOUTCLK2_OUT,
    MGT1_TXUSRCLK2_IN

);

// synthesis attribute X_CORE_INFO of ROCKETIO is "v4fx_mgtwizard_v1_7, Coregen v12.1";

//***************************** Port Declarations ******************************
        


    //__________________________________________________________________________
    //__________________________________________________________________________
    //MGT0  (X1Y2)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    output  [3:0]       MGT0_RXCHARISCOMMA_OUT;
    output  [3:0]       MGT0_RXCHARISK_OUT;
    output  [31:0]      MGT0_RXDATA_OUT;
    output  [3:0]       MGT0_RXDISPERR_OUT;
    output  [3:0]       MGT0_RXNOTINTABLE_OUT;
    output  [3:0]       MGT0_RXRUNDISP_OUT;
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    input   [3:0]       MGT0_TXBYPASS8B10B_IN;
    input   [3:0]       MGT0_TXCHARDISPMODE_IN;
    input   [3:0]       MGT0_TXCHARDISPVAL_IN;
    input   [3:0]       MGT0_TXCHARISK_IN;
    input   [31:0]      MGT0_TXDATA_IN;
    output  [3:0]       MGT0_TXKERR_OUT;
    output  [3:0]       MGT0_TXRUNDISP_OUT;
    //------------------------ Calibration Block Ports -------------------------
    output              MGT0_ACTIVE_OUT;
    input               MGT0_DISABLE_IN;
    input               MGT0_DRP_RESET_IN;
    input               MGT0_RX_SIGNAL_DETECT_IN;
    input               MGT0_TX_SIGNAL_DETECT_IN;
    //--------------------------- Calibration Ports ----------------------------
    input               MGT0_RXCLKSTABLE_IN;
    input               MGT0_TXCLKSTABLE_IN;
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    input   [7:0]       MGT0_DADDR_IN;
    input               MGT0_DCLK_IN;
    input               MGT0_DEN_IN;
    input   [15:0]      MGT0_DI_IN;
    output  [15:0]      MGT0_DO_OUT;
    output              MGT0_DRDY_OUT;
    input               MGT0_DWE_IN;
    //------------------------------ Global Ports ------------------------------
    input   [1:0]       MGT0_LOOPBACK_IN;
    input               MGT0_POWERDOWN_IN;
    input               MGT0_TXINHIBIT_IN;
    //---------------------- Out of Band Signalling Ports ----------------------
    output              MGT0_RXSIGDET_OUT;
    input               MGT0_TXENOOB_IN;
    //-------------------------------- PLL Lock --------------------------------
    output              MGT0_RXLOCK_OUT;
    output              MGT0_TXLOCK_OUT;
    //------------------------- Polarity Control Ports -------------------------
    input               MGT0_RXPOLARITY_IN;
    input               MGT0_TXPOLARITY_IN;
    //-------------------------- Ports for Simulation --------------------------
    input   [15:0]      MGT0_COMBUSIN_IN;
    output  [15:0]      MGT0_COMBUSOUT_OUT;
    //---------------------------- Reference Clocks ----------------------------
    input               MGT0_REFCLK1_IN;
    //--------------------------------- Resets ---------------------------------
    input               MGT0_RXPMARESET_IN;
    input               MGT0_RXRESET_IN;
    input               MGT0_TXPMARESET_IN;
    input               MGT0_TXRESET_IN;
    //---------------------------- Serdes Alignment ----------------------------
    input               MGT0_ENMCOMMAALIGN_IN;
    input               MGT0_ENPCOMMAALIGN_IN;
    output              MGT0_RXCOMMADET_OUT;
    output              MGT0_RXREALIGN_OUT;
    //------------------------------ Serial Ports ------------------------------
    input               MGT0_RX1N_IN;
    input               MGT0_RX1P_IN;
    output              MGT0_TX1N_OUT;
    output              MGT0_TX1P_OUT;
    //--------------------------------- Status ---------------------------------
    output  [5:0]       MGT0_RXSTATUS_OUT;
    //---------------------------- Synchronization -----------------------------
    input               MGT0_RXSYNC_IN;
    input               MGT0_TXSYNC_IN;
    //------------------------------ User Clocks -------------------------------
    output              MGT0_RXRECCLK1_OUT;
    output              MGT0_RXRECCLK2_OUT;
    input               MGT0_RXUSRCLK2_IN;
    output              MGT0_TXOUTCLK1_OUT;
    output              MGT0_TXOUTCLK2_OUT;
    input               MGT0_TXUSRCLK2_IN;


    //__________________________________________________________________________
    //__________________________________________________________________________
    //MGT1  (X1Y3)

    //--------------- 8B10B Receive Data Path and Control Ports ----------------
    output  [3:0]       MGT1_RXCHARISCOMMA_OUT;
    output  [3:0]       MGT1_RXCHARISK_OUT;
    output  [31:0]      MGT1_RXDATA_OUT;
    output  [3:0]       MGT1_RXDISPERR_OUT;
    output  [3:0]       MGT1_RXNOTINTABLE_OUT;
    output  [3:0]       MGT1_RXRUNDISP_OUT;
    //--------------- 8B10B Transmit Data Path and Control Ports ---------------
    input   [3:0]       MGT1_TXBYPASS8B10B_IN;
    input   [3:0]       MGT1_TXCHARDISPMODE_IN;
    input   [3:0]       MGT1_TXCHARDISPVAL_IN;
    input   [3:0]       MGT1_TXCHARISK_IN;
    input   [31:0]      MGT1_TXDATA_IN;
    output  [3:0]       MGT1_TXKERR_OUT;
    output  [3:0]       MGT1_TXRUNDISP_OUT;
    //------------------------ Calibration Block Ports -------------------------
    output              MGT1_ACTIVE_OUT;
    input               MGT1_DISABLE_IN;
    input               MGT1_DRP_RESET_IN;
    input               MGT1_RX_SIGNAL_DETECT_IN;
    input               MGT1_TX_SIGNAL_DETECT_IN;
    //--------------------------- Calibration Ports ----------------------------
    input               MGT1_RXCLKSTABLE_IN;
    input               MGT1_TXCLKSTABLE_IN;
    //------------------- Dynamic Reconfiguration Port (DRP) -------------------
    input   [7:0]       MGT1_DADDR_IN;
    input               MGT1_DCLK_IN;
    input               MGT1_DEN_IN;
    input   [15:0]      MGT1_DI_IN;
    output  [15:0]      MGT1_DO_OUT;
    output              MGT1_DRDY_OUT;
    input               MGT1_DWE_IN;
    //------------------------------ Global Ports ------------------------------
    input   [1:0]       MGT1_LOOPBACK_IN;
    input               MGT1_POWERDOWN_IN;
    input               MGT1_TXINHIBIT_IN;
    //---------------------- Out of Band Signalling Ports ----------------------
    output              MGT1_RXSIGDET_OUT;
    input               MGT1_TXENOOB_IN;
    //-------------------------------- PLL Lock --------------------------------
    output              MGT1_RXLOCK_OUT;
    output              MGT1_TXLOCK_OUT;
    //------------------------- Polarity Control Ports -------------------------
    input               MGT1_RXPOLARITY_IN;
    input               MGT1_TXPOLARITY_IN;
    //-------------------------- Ports for Simulation --------------------------
    input   [15:0]      MGT1_COMBUSIN_IN;
    output  [15:0]      MGT1_COMBUSOUT_OUT;
    //---------------------------- Reference Clocks ----------------------------
    input               MGT1_REFCLK1_IN;
    //--------------------------------- Resets ---------------------------------
    input               MGT1_RXPMARESET_IN;
    input               MGT1_RXRESET_IN;
    input               MGT1_TXPMARESET_IN;
    input               MGT1_TXRESET_IN;
    //---------------------------- Serdes Alignment ----------------------------
    input               MGT1_ENMCOMMAALIGN_IN;
    input               MGT1_ENPCOMMAALIGN_IN;
    output              MGT1_RXCOMMADET_OUT;
    output              MGT1_RXREALIGN_OUT;
    //------------------------------ Serial Ports ------------------------------
    input               MGT1_RX1N_IN;
    input               MGT1_RX1P_IN;
    output              MGT1_TX1N_OUT;
    output              MGT1_TX1P_OUT;
    //--------------------------------- Status ---------------------------------
    output  [5:0]       MGT1_RXSTATUS_OUT;
    //---------------------------- Synchronization -----------------------------
    input               MGT1_RXSYNC_IN;
    input               MGT1_TXSYNC_IN;
    //------------------------------ User Clocks -------------------------------
    output              MGT1_RXRECCLK1_OUT;
    output              MGT1_RXRECCLK2_OUT;
    input               MGT1_RXUSRCLK2_IN;
    output              MGT1_TXOUTCLK1_OUT;
    output              MGT1_TXOUTCLK2_OUT;
    input               MGT1_TXUSRCLK2_IN;




//************************** Parameter Declarations ****************************

    parameter   SIMULATION_P        =   0;      //Set to 1 when simulating
    parameter   RX_FD_EN_P          =   1'b1;   //1=enable calblock RX frequency checker
    parameter   TX_FD_EN_P          =   1'b1;   //1=enable calblock TX frequency checker
    parameter   TX_FD_MIN_P         =   11'h0a7;      // floor (128*Tpclk/Tdclk) - 3 
    parameter   RX_FD_MIN_P         =   11'h0a7;      // floor (128*Tpclk/Tdclk) - 3
    parameter   TX_FD_WIDTH_P       =   11;       // TX Fdetect MIN value width
    parameter   RX_FD_WIDTH_P       =   11;       // RX Fdetect MIN value width
    
    parameter   RXDATAWIDTH_P       =   2'b10;
    parameter   TXDATAWIDTH_P       =   2'b10;
    parameter   RXINTDATAWIDTH_P    =   2'b11;
    parameter   TXINTDATAWIDTH_P    =   2'b11;

    
    parameter   MGT0_GT11_MODE_P         =   "B";        // Default Location
    parameter   MGT0_MGT_ID_P            =   1;          // 0=A, 1=B    
    
    parameter   MGT1_GT11_MODE_P         =   "A";        // Default Location
    parameter   MGT1_MGT_ID_P            =   0;          // 0=A, 1=B    

//***************************** Wire Declarations ******************************

    // ground and vcc signals
    wire               tied_to_ground_i;
    wire    [63:0]     tied_to_ground_vec_i;
    wire               tied_to_vcc_i;
    wire    [63:0]     tied_to_vcc_vec_i;

    // channel bond signals
    wire    [4:0]      mgt0_chbondo_i;
    // calblock connection signals
    wire    [7:0]      mgt0_daddr_i;
    wire               mgt0_den_i;
    wire    [15:0]     mgt0_di_i;
    wire    [15:0]     mgt0_do_i;
    wire               mgt0_drdy_i;
    wire               mgt0_dwe_i;
    wire               mgt0_rxlock_i;
    wire               mgt0_txlock_i;
    wire    [1:0]      mgt0_loopback_i;
    wire               mgt0_txenc8b10buse_i;
    wire    [7:0]      mgt0_txbypass8b10b_i;
    wire               mgt0_rxpmareset_i;
    wire               mgt0_txpmareset_i;
    wire               mgt0_txoutclk1_i;
    wire               mgt0_rxrecclk2_i;
    wire               mgt0_txoutclk1_buf_i;
    wire               mgt0_rxrecclk2_buf_i;    
    wire    [3:0]      mgt0_rxchariscomma_out_float_i;
    wire    [3:0]      mgt0_rxcharisk_out_float_i;
    wire    [31:0]     mgt0_rxdata_out_float_i;
    wire    [3:0]      mgt0_rxdisperr_out_float_i;
    wire    [3:0]      mgt0_rxnotintable_out_float_i;
    wire    [3:0]      mgt0_rxrundisp_out_float_i;
    wire    [3:0]      mgt0_txkerr_out_float_i;
    wire    [3:0]      mgt0_txrundisp_out_float_i;
    // channel bond signals
    wire    [4:0]      mgt1_chbondo_i;
    // calblock connection signals
    wire    [7:0]      mgt1_daddr_i;
    wire               mgt1_den_i;
    wire    [15:0]     mgt1_di_i;
    wire    [15:0]     mgt1_do_i;
    wire               mgt1_drdy_i;
    wire               mgt1_dwe_i;
    wire               mgt1_rxlock_i;
    wire               mgt1_txlock_i;
    wire    [1:0]      mgt1_loopback_i;
    wire               mgt1_txenc8b10buse_i;
    wire    [7:0]      mgt1_txbypass8b10b_i;
    wire               mgt1_rxpmareset_i;
    wire               mgt1_txpmareset_i;
    wire               mgt1_txoutclk1_i;
    wire               mgt1_rxrecclk2_i;
    wire               mgt1_txoutclk1_buf_i;
    wire               mgt1_rxrecclk2_buf_i;    
    wire    [3:0]      mgt1_rxchariscomma_out_float_i;
    wire    [3:0]      mgt1_rxcharisk_out_float_i;
    wire    [31:0]     mgt1_rxdata_out_float_i;
    wire    [3:0]      mgt1_rxdisperr_out_float_i;
    wire    [3:0]      mgt1_rxnotintable_out_float_i;
    wire    [3:0]      mgt1_rxrundisp_out_float_i;
    wire    [3:0]      mgt1_txkerr_out_float_i;
    wire    [3:0]      mgt1_txrundisp_out_float_i;





//***************************** Main Body of Code ******************************

    //-------------------------  Static signal Assigments ----------------------   
    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 64'hffffffffffffffff;



    //__________________________________________________________________________
    //__________________________________________________________________________
    //MGT0  (X1Y2)


    


    //------------------------- GT11 Instantiations  ---------------------------   

    GT11 MGT0
    (
        //----------------------------- CRC Ports ------------------------------  

        .RXCRCCLK                    (tied_to_ground_i), 
        .RXCRCDATAVALID              (tied_to_ground_i), 
        .RXCRCDATAWIDTH              (tied_to_ground_vec_i[2:0]), 
        .RXCRCIN                     (tied_to_ground_vec_i[63:0]), 
        .RXCRCINIT                   (tied_to_ground_i), 
        .RXCRCINTCLK                 (tied_to_ground_i), 
        .RXCRCOUT                    ( ),                        
        .RXCRCPD                     (tied_to_vcc_i), 
        .RXCRCRESET                  (tied_to_ground_i), 

        .TXCRCCLK                    (tied_to_ground_i), 
        .TXCRCDATAVALID              (tied_to_ground_i), 
        .TXCRCDATAWIDTH              (tied_to_ground_vec_i[2:0]), 
        .TXCRCIN                     (tied_to_ground_vec_i[63:0]), 
        .TXCRCINIT                   (tied_to_ground_i), 
        .TXCRCINTCLK                 (tied_to_ground_i), 
        .TXCRCOUT                    ( ),                        
        .TXCRCPD                     (tied_to_vcc_i),                       
        .TXCRCRESET                  (tied_to_ground_i), 

         //-------------------------- Calibration Ports ------------------------   

        .RXCALFAIL                   ( ),                       
        .RXCYCLELIMIT                ( ),                    
        .TXCALFAIL                   ( ),                         
        .TXCYCLELIMIT                ( ),                     

        //---------------------------- Serial Ports ----------------------------   

        .RX1N                        (MGT0_RX1N_IN), 
        .RX1P                        (MGT0_RX1P_IN), 
        .TX1N                        (MGT0_TX1N_OUT), 
        .TX1P                        (MGT0_TX1P_OUT),


        //----------------------------- PLL Lock -------------------------------   

        .RXLOCK                      (mgt0_rxlock_i),
        .TXLOCK                      (mgt0_txlock_i),  


        //------------------------------ Resets --------------------------------  

        .RXPMARESET                  (mgt0_rxpmareset_i), 
        .RXRESET                     (MGT0_RXRESET_IN), 
        .TXPMARESET                  (mgt0_txpmareset_i), 
        .TXRESET                     (MGT0_TXRESET_IN), 

        //-------------------------- Synchronization ---------------------------   

        .RXSYNC                      (MGT0_RXSYNC_IN), 
        .TXSYNC                      (MGT0_TXSYNC_IN),    

        //-------------------------- Out of Band Signalling --------------------   

        .RXSIGDET                    (MGT0_RXSIGDET_OUT),                      
        .TXENOOB                     (MGT0_TXENOOB_IN), 
 
        //------------------------------ Status --------------------------------   

        .RXBUFERR                    ( ), 
        .RXCLKSTABLE                 (MGT0_RXCLKSTABLE_IN), 
        .RXSTATUS                    (MGT0_RXSTATUS_OUT), 
        .TXBUFERR                    ( ), 
        .TXCLKSTABLE                 (MGT0_TXCLKSTABLE_IN), 
  
        //-------------------------- Polarity Control Ports -------------------- 

        .RXPOLARITY                  (MGT0_RXPOLARITY_IN), 
        .TXINHIBIT                   (MGT0_TXINHIBIT_IN), 
        .TXPOLARITY                  (MGT0_TXPOLARITY_IN), 

        //----------------------------- Channel Bonding Ports ------------------   

        .CHBONDI                     (tied_to_ground_vec_i[4:0]), 
        .CHBONDO                     (mgt0_chbondo_i), 
        .ENCHANSYNC                  (tied_to_ground_i), 
 
        //-------------------------- 64B66B Blocks Use Ports -------------------   

        .RXBLOCKSYNC64B66BUSE        (tied_to_ground_i), 
        .RXDEC64B66BUSE              (tied_to_ground_i), 
        .RXDESCRAM64B66BUSE          (tied_to_ground_i), 
        .RXIGNOREBTF                 (tied_to_ground_i),   
        .TXENC64B66BUSE              (tied_to_ground_i), 
        .TXGEARBOX64B66BUSE          (tied_to_ground_i), 
        .TXSCRAM64B66BUSE            (tied_to_ground_i), 

        //-------------------------- 8B10B Blocks Use Ports --------------------   

        .RXDEC8B10BUSE               (tied_to_vcc_i), 
        .TXBYPASS8B10B               (mgt0_txbypass8b10b_i), 
        .TXENC8B10BUSE               (mgt0_txenc8b10buse_i), 

        //---------------------------- Transmit Control Ports ------------------   
        .TXCHARDISPMODE              ({tied_to_ground_vec_i[3:0],MGT0_TXCHARDISPMODE_IN[3:0]}), 
        .TXCHARDISPVAL               ({tied_to_ground_vec_i[3:0],MGT0_TXCHARDISPVAL_IN[3:0]}), 
        .TXCHARISK                   ({tied_to_ground_vec_i[3:0],MGT0_TXCHARISK_IN[3:0]}), 
        .TXKERR                      ({mgt0_txkerr_out_float_i[3:0],MGT0_TXKERR_OUT[3:0]}),                   
        .TXRUNDISP                   ({mgt0_txrundisp_out_float_i[3:0],MGT0_TXRUNDISP_OUT[3:0]}),                

        //---------------------------- Receive Control Ports -------------------   

        .RXCHARISCOMMA               ({mgt0_rxchariscomma_out_float_i[3:0],MGT0_RXCHARISCOMMA_OUT[3:0]}), 
        .RXCHARISK                   ({mgt0_rxcharisk_out_float_i[3:0],MGT0_RXCHARISK_OUT[3:0]}), 
        .RXDISPERR                   ({mgt0_rxdisperr_out_float_i[3:0],MGT0_RXDISPERR_OUT[3:0]}), 
        .RXNOTINTABLE                ({mgt0_rxnotintable_out_float_i[3:0],MGT0_RXNOTINTABLE_OUT[3:0]}), 
        .RXRUNDISP                   ({mgt0_rxrundisp_out_float_i[3:0],MGT0_RXRUNDISP_OUT[3:0]}),            

        //----------------------------- Serdes Alignment -----------------------  

        .ENMCOMMAALIGN               (MGT0_ENMCOMMAALIGN_IN), 
        .ENPCOMMAALIGN               (MGT0_ENPCOMMAALIGN_IN),
        .RXCOMMADET                  (MGT0_RXCOMMADET_OUT),                   
        .RXCOMMADETUSE               (tied_to_vcc_i), 
        .RXLOSSOFSYNC                ( ),           
        .RXREALIGN                   (MGT0_RXREALIGN_OUT), 
        .RXSLIDE                     (tied_to_ground_i), 

        //--------- Data Width Settings - Internal and fabric interface -------- 

        .RXDATAWIDTH                 (RXDATAWIDTH_P),        //parameter
        .RXINTDATAWIDTH              (RXINTDATAWIDTH_P),     //parameter 
        .TXDATAWIDTH                 (TXDATAWIDTH_P),        //parameter
        .TXINTDATAWIDTH              (TXINTDATAWIDTH_P),     //parameter 

        //----------------------------- Data Ports -----------------------------    

        .RXDATA                      ({mgt0_rxdata_out_float_i[31:0],MGT0_RXDATA_OUT[31:0]}), 
        .TXDATA                      ({tied_to_ground_vec_i[31:0],MGT0_TXDATA_IN[31:0]}), 

       //----------------------------- User Clocks -----------------------------   

        .RXMCLK                      ( ), 
        .RXPCSHCLKOUT                ( ), 
        .RXRECCLK1                   (MGT0_RXRECCLK1_OUT),     
        .RXRECCLK2                   (mgt0_rxrecclk2_i),     
        .RXUSRCLK                    (tied_to_ground_i), 
        .RXUSRCLK2                   (MGT0_RXUSRCLK2_IN), 
        .TXOUTCLK1                   (mgt0_txoutclk1_i), 
        .TXOUTCLK2                   (MGT0_TXOUTCLK2_OUT), 
        .TXPCSHCLKOUT                ( ),
        .TXUSRCLK                    (tied_to_ground_i), 
        .TXUSRCLK2                   (MGT0_TXUSRCLK2_IN), 


        //-------------------------- Reference Clocks --------------------------   

        .GREFCLK                     (tied_to_ground_i), 
        .REFCLK1                     (MGT0_REFCLK1_IN),        
        .REFCLK2                     (tied_to_ground_i), 

        //-------------------------- Powerdown and Loopback Ports --------------  

        .LOOPBACK                    (mgt0_loopback_i), 
        .POWERDOWN                   (MGT0_POWERDOWN_IN),

       //----------------- Dynamic Reconfiguration Port (DRP) ------------------
 
        .DADDR                       (mgt0_daddr_i),  
        .DCLK                        (MGT0_DCLK_IN), 
        .DEN                         (mgt0_den_i), 
        .DI                          (mgt0_di_i),    
        .DO                          (mgt0_do_i),                             
        .DRDY                        (mgt0_drdy_i),                            
        .DWE                         (mgt0_dwe_i), 

           //------------------- MGT Tile Communication Ports ------------------       

        .COMBUSIN                    (MGT0_COMBUSIN_IN), 
        .COMBUSOUT                   (MGT0_COMBUSOUT_OUT) 
    );


    //-------- RocketIO MGT 64B66B Block Sync State Machine Attributes --------- 

    defparam MGT0.SH_CNT_MAX              = 64;
    defparam MGT0.SH_INVALID_CNT_MAX      = 16;

    //--------------------- RocketIO MGT Alignment Atrributes ------------------   

    defparam MGT0.ALIGN_COMMA_WORD        = 4;
    defparam MGT0.COMMA_10B_MASK          = 10'h3ff;
    defparam MGT0.COMMA32                 = "FALSE";
    defparam MGT0.DEC_MCOMMA_DETECT       = "TRUE";
    defparam MGT0.DEC_PCOMMA_DETECT       = "TRUE";
    defparam MGT0.DEC_VALID_COMMA_ONLY    = "TRUE";
    defparam MGT0.MCOMMA_32B_VALUE        = 32'h0000017c;
    defparam MGT0.MCOMMA_DETECT           = "TRUE";
    defparam MGT0.PCOMMA_32B_VALUE        = 32'h00000283;
    defparam MGT0.PCOMMA_DETECT           = "TRUE";
    defparam MGT0.PCS_BIT_SLIP            = "FALSE";   

    //-- RocketIO MGT Atrributes Common to Clk Correction & Channel Bonding ----   

    defparam MGT0.CCCB_ARBITRATOR_DISABLE = "FALSE";
    defparam MGT0.CLK_COR_8B10B_DE        = "TRUE";    

    //----------------- RocketIO MGT Channel Bonding Atrributes ----------------   
    
    defparam MGT0.CHAN_BOND_LIMIT         = 16;
    defparam MGT0.CHAN_BOND_MODE          = "NONE";
    defparam MGT0.CHAN_BOND_ONE_SHOT      = "FALSE";
    defparam MGT0.CHAN_BOND_SEQ_1_1       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_1_2       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_1_3       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_1_4       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_1_MASK    = 4'b1110;
    defparam MGT0.CHAN_BOND_SEQ_2_1       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_2_2       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_2_3       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_2_4       = 11'b00000000000;
    defparam MGT0.CHAN_BOND_SEQ_2_MASK    = 4'b1111;
    defparam MGT0.CHAN_BOND_SEQ_2_USE     = "FALSE";
    defparam MGT0.CHAN_BOND_SEQ_LEN       = 1;    

    //---------------- RocketIO MGT Clock Correction Atrributes ----------------   

    defparam MGT0.CLK_COR_MAX_LAT         = 40;
    defparam MGT0.CLK_COR_MIN_LAT         = 28;
    defparam MGT0.CLK_COR_SEQ_1_1         = 11'b00101111100;
    defparam MGT0.CLK_COR_SEQ_1_2         = 11'b00010010101;
    defparam MGT0.CLK_COR_SEQ_1_3         = 11'b00010110101;
    defparam MGT0.CLK_COR_SEQ_1_4         = 11'b00010110101;
    defparam MGT0.CLK_COR_SEQ_1_MASK      = 4'b0000;
    defparam MGT0.CLK_COR_SEQ_2_1         = 11'b00110111100;
    defparam MGT0.CLK_COR_SEQ_2_2         = 11'b00001001010;
    defparam MGT0.CLK_COR_SEQ_2_3         = 11'b00001001010;
    defparam MGT0.CLK_COR_SEQ_2_4         = 11'b00001111011;
    defparam MGT0.CLK_COR_SEQ_2_MASK      = 4'b0000;
    defparam MGT0.CLK_COR_SEQ_2_USE       = "TRUE";
    defparam MGT0.CLK_COR_SEQ_DROP        = "FALSE";
    defparam MGT0.CLK_COR_SEQ_LEN         = 4;
    defparam MGT0.CLK_CORRECT_USE         = "FALSE";    
    
    //-------------------- RocketIO MGT Clocking Atrributes --------------------      

    defparam MGT0.RX_CLOCK_DIVIDER        = 2'b11;
    defparam MGT0.RXASYNCDIVIDE           = 2'b10;
    defparam MGT0.RXCLK0_FORCE_PMACLK     = "FALSE";
    defparam MGT0.RXCLKMODE               = 6'b000011;
    defparam MGT0.RXOUTDIV2SEL            = 4;
    defparam MGT0.RXPLLNDIVSEL            = 20;
    defparam MGT0.RXPMACLKSEL             = "REFCLK1";
    defparam MGT0.RXRECCLK1_USE_SYNC      = "FALSE";
    defparam MGT0.RXUSRDIVISOR            = 1;
    defparam MGT0.TX_CLOCK_DIVIDER        = 2'b11;
    defparam MGT0.TXABPMACLKSEL           = "REFCLK1";
    defparam MGT0.TXASYNCDIVIDE           = 2'b10;
    defparam MGT0.TXCLK0_FORCE_PMACLK     = "FALSE";
    defparam MGT0.TXCLKMODE               = 4'b0100;
    defparam MGT0.TXOUTCLK1_USE_SYNC      = "FALSE";
    defparam MGT0.TXOUTDIV2SEL            = 4;
    defparam MGT0.TXPHASESEL              = "TRUE"; 
    defparam MGT0.TXPLLNDIVSEL            = 20;

    //------------------------ RocketIO MGT CRC Atrributes ---------------------   

    defparam MGT0.RXCRCCLOCKDOUBLE        = "FALSE";
    defparam MGT0.RXCRCENABLE             = "FALSE";
    defparam MGT0.RXCRCINITVAL            = 32'h00000000;
    defparam MGT0.RXCRCINVERTGEN          = "FALSE";
    defparam MGT0.RXCRCSAMECLOCK          = "TRUE";
    defparam MGT0.TXCRCCLOCKDOUBLE        = "FALSE";
    defparam MGT0.TXCRCENABLE             = "FALSE";
    defparam MGT0.TXCRCINITVAL            = 32'h00000000;
    defparam MGT0.TXCRCINVERTGEN          = "FALSE";
    defparam MGT0.TXCRCSAMECLOCK          = "TRUE";
        
    //------------------- RocketIO MGT Data Path Atrributes --------------------   

    defparam MGT0.RXDATA_SEL              = 2'b11;
    defparam MGT0.TXDATA_SEL              = 2'b10;

    //-------------- RocketIO MGT Digital Receiver Attributes ------------------   

    defparam MGT0.DIGRX_FWDCLK            = 2'b00;
    defparam MGT0.DIGRX_SYNC_MODE         = "TRUE";
    defparam MGT0.ENABLE_DCDR             = "FALSE";
    defparam MGT0.RXBY_32                 = "FALSE";
    defparam MGT0.RXDIGRESET              = "FALSE";
    defparam MGT0.RXDIGRX                 = "FALSE";
    defparam MGT0.SAMPLE_8X               = "FALSE";

    //--------------- Rocket IO MGT Miscellaneous Attributes ------------------     

    defparam MGT0.GT11_MODE               = MGT0_GT11_MODE_P;
    defparam MGT0.OPPOSITE_SELECT         = "FALSE";
    defparam MGT0.PMA_BIT_SLIP            = "FALSE";
    defparam MGT0.REPEATER                = "FALSE";
    defparam MGT0.RX_BUFFER_USE           = "FALSE";
    defparam MGT0.RXCDRLOS                = 6'b000000;
    defparam MGT0.RXDCCOUPLE              = "FALSE";
    defparam MGT0.RXFDCAL_CLOCK_DIVIDE    = "NONE";
    defparam MGT0.TX_BUFFER_USE           = "FALSE";     
    defparam MGT0.TXFDCAL_CLOCK_DIVIDE    = "NONE";
    defparam MGT0.TXSLEWRATE              = "TRUE";

    //--------------- Rocket IO MGT Preemphasis and Equalization --------------
    
    defparam MGT0.RXAFEEQ                  = 9'b000000000;
    defparam MGT0.RXEQ                     = 64'h4000000000000000;
    defparam MGT0.TXDAT_PRDRV_DAC          = 3'b111;
    defparam MGT0.TXDAT_TAP_DAC            = 5'b10110;    
    defparam MGT0.TXHIGHSIGNALEN           = "TRUE";
    defparam MGT0.TXPOST_PRDRV_DAC         = 3'b111;
    defparam MGT0.TXPOST_TAP_DAC           = 5'b00001;
    defparam MGT0.TXPOST_TAP_PD            = "TRUE";
    defparam MGT0.TXPRE_PRDRV_DAC          = 3'b111;
    defparam MGT0.TXPRE_TAP_DAC            = 5'b00000;
    defparam MGT0.TXPRE_TAP_PD             = "TRUE";           
    

    //--------------------- Restricted RocketIO MGT Attributes -------------------  

    ///Note : THE FOLLOWING ATTRIBUTES ARE RESTRICTED. PLEASE DO NOT EDIT.

    //--------------------------- Restricted: Biasing -------------------------
    
    defparam MGT0.BANDGAPSEL               = "FALSE";
    defparam MGT0.BIASRESSEL               = "FALSE";    
    defparam MGT0.IREFBIASMODE             = 2'b11;
    defparam MGT0.PMAIREFTRIM              = 4'b0111;
    defparam MGT0.PMAVREFTRIM              = 4'b0111;
    defparam MGT0.TXAREFBIASSEL            = "TRUE"; 
    defparam MGT0.TXTERMTRIM               = 4'b1100;
    defparam MGT0.VREFBIASMODE             = 2'b11;

    //-------------- Restricted: Frequency Detector and Calibration -----------   
     
    defparam MGT0.CYCLE_LIMIT_SEL          = 2'b00;
    defparam MGT0.FDET_HYS_CAL             = 3'b010;
    defparam MGT0.FDET_HYS_SEL             = 3'b100;
    defparam MGT0.FDET_LCK_CAL             = 3'b101;
    defparam MGT0.FDET_LCK_SEL             = 3'b001;
    defparam MGT0.LOOPCAL_WAIT             = 2'b00;
    defparam MGT0.RXCYCLE_LIMIT_SEL        = 2'b00;
    defparam MGT0.RXFDET_HYS_CAL           = 3'b010;
    defparam MGT0.RXFDET_HYS_SEL           = 3'b100;
    defparam MGT0.RXFDET_LCK_CAL           = 3'b101;   
    defparam MGT0.RXFDET_LCK_SEL           = 3'b001;
    defparam MGT0.RXLOOPCAL_WAIT           = 2'b00;
    defparam MGT0.RXSLOWDOWN_CAL           = 2'b00;
    defparam MGT0.SLOWDOWN_CAL             = 2'b00;
    
    //------------------------- Restricted: PLL Settings ----------------------
    
    defparam MGT0.PMACLKENABLE             = "TRUE";
    defparam MGT0.PMACOREPWRENABLE         = "TRUE";
    defparam MGT0.PMAVBGCTRL               = 5'b00000;
    defparam MGT0.RXACTST                  = "FALSE";       
    defparam MGT0.RXAFETST                 = "FALSE";      
    defparam MGT0.RXCMADJ                  = 2'b01;
    defparam MGT0.RXCPSEL                  = "FALSE";
    defparam MGT0.RXCPTST                  = "FALSE";
    defparam MGT0.RXCTRL1                  = 10'h200;
    defparam MGT0.RXFECONTROL1             = 2'b00; 
    defparam MGT0.RXFECONTROL2             = 3'b000; 
    defparam MGT0.RXFETUNE                 = 2'b01; 
    defparam MGT0.RXLKADJ                  = 5'b00000;
    defparam MGT0.RXLOOPFILT               = 4'b1111;
    defparam MGT0.RXPDDTST                 = "TRUE";      
    defparam MGT0.RXRCPADJ                 = 3'b011; 
    defparam MGT0.RXRIBADJ                 = 2'b11;
    defparam MGT0.RXVCO_CTRL_ENABLE        = "TRUE";
    defparam MGT0.RXVCODAC_INIT            = 10'b0000101001;   
    defparam MGT0.TXCPSEL                  = "FALSE";
    defparam MGT0.TXCTRL1                  = 10'h200;
    defparam MGT0.TXLOOPFILT               = 4'b1101;   
    defparam MGT0.VCO_CTRL_ENABLE          = "TRUE";
    defparam MGT0.VCODAC_INIT              = 10'b0000101001;
    
    //------------------------- Restricted: Powerdowns ------------------------
     
    defparam MGT0.POWER_ENABLE             = "TRUE";
    defparam MGT0.RXAFEPD                  = "FALSE";
    defparam MGT0.RXAPD                    = "FALSE";
    defparam MGT0.RXLKAPD                  = "FALSE";
    defparam MGT0.RXPD                     = "FALSE";
    defparam MGT0.RXRCPPD                  = "FALSE";
    defparam MGT0.RXRPDPD                  = "FALSE";
    defparam MGT0.RXRSDPD                  = "FALSE";
    defparam MGT0.TXAPD                    = "FALSE";
    defparam MGT0.TXDIGPD                  = "FALSE";
    defparam MGT0.TXLVLSHFTPD              = "FALSE";
    defparam MGT0.TXPD                     = "FALSE";





    //----------------------------- Calibration Block --------------------------




    // Some signals are intercepted by different versions of the calblock. Here, we simply connect them
    assign  mgt0_rxpmareset_i    =   MGT0_RXPMARESET_IN;
    assign  MGT0_RXLOCK_OUT   =   mgt0_rxlock_i;
    assign  MGT0_TXLOCK_OUT   =   mgt0_txlock_i;
    assign  mgt0_txpmareset_i    =   MGT0_TXPMARESET_IN;    
    assign  MGT0_RXRECCLK2_OUT   =   mgt0_rxrecclk2_i;
    assign  MGT0_TXOUTCLK1_OUT   =   mgt0_txoutclk1_i;



    cal_block_v1_4_1 #
    (
      .C_MGT_ID           (MGT0_MGT_ID_P),                        // 0 = MGTA | 1 = MGTB 
      .C_TXPOST_TAP_PD    ("TRUE"),                   // Default POST TAP PD
      .C_RXDIGRX          ("FALSE")                          // Default RXDIGRX
    ) 
    MGT0_CAL_BLOCK
    (
      // User DRP Interface (destination/slave interface)
      .USER_DO            (MGT0_DO_OUT),
      .USER_DI            (MGT0_DI_IN),
      .USER_DADDR         (MGT0_DADDR_IN),
      .USER_DEN           (MGT0_DEN_IN),
      .USER_DWE           (MGT0_DWE_IN),
      .USER_DRDY          (MGT0_DRDY_OUT),
    
      // MGT DRP Interface (source/master interface)
      .GT_DO              (mgt0_di_i),
      .GT_DI              (mgt0_do_i),
      .GT_DADDR           (mgt0_daddr_i),
      .GT_DEN             (mgt0_den_i),
      .GT_DWE             (mgt0_dwe_i),
      .GT_DRDY            (mgt0_drdy_i),
    
      // Calibration Block Active and Disable Signals 
      .ACTIVE             (MGT0_ACTIVE_OUT),
        
      // User side MGT Pass through Signals
      .USER_LOOPBACK      (MGT0_LOOPBACK_IN),
      .USER_TXENC8B10BUSE (tied_to_vcc_i),
      .USER_TXBYPASS8B10B ({tied_to_ground_vec_i[3:0],MGT0_TXBYPASS8B10B_IN[3:0]}), 

      // GT side MGT Pass through Signals
      .GT_LOOPBACK        (mgt0_loopback_i),
      .GT_TXENC8B10BUSE   (mgt0_txenc8b10buse_i),
      .GT_TXBYPASS8B10B   (mgt0_txbypass8b10b_i),

      // Signal Detect Ports
      .TX_SIGNAL_DETECT   (MGT0_TX_SIGNAL_DETECT_IN),
      .RX_SIGNAL_DETECT   (MGT0_RX_SIGNAL_DETECT_IN),

      // Clock and Reset
      .DCLK               (MGT0_DCLK_IN),
      .RESET              (MGT0_DRP_RESET_IN)
    );

     
    
  


    //__________________________________________________________________________
    //__________________________________________________________________________
    //MGT1  (X1Y3)


    


    //------------------------- GT11 Instantiations  ---------------------------   

    GT11 MGT1
    (
        //----------------------------- CRC Ports ------------------------------  

        .RXCRCCLK                    (tied_to_ground_i), 
        .RXCRCDATAVALID              (tied_to_ground_i), 
        .RXCRCDATAWIDTH              (tied_to_ground_vec_i[2:0]), 
        .RXCRCIN                     (tied_to_ground_vec_i[63:0]), 
        .RXCRCINIT                   (tied_to_ground_i), 
        .RXCRCINTCLK                 (tied_to_ground_i), 
        .RXCRCOUT                    ( ),                        
        .RXCRCPD                     (tied_to_vcc_i), 
        .RXCRCRESET                  (tied_to_ground_i), 

        .TXCRCCLK                    (tied_to_ground_i), 
        .TXCRCDATAVALID              (tied_to_ground_i), 
        .TXCRCDATAWIDTH              (tied_to_ground_vec_i[2:0]), 
        .TXCRCIN                     (tied_to_ground_vec_i[63:0]), 
        .TXCRCINIT                   (tied_to_ground_i), 
        .TXCRCINTCLK                 (tied_to_ground_i), 
        .TXCRCOUT                    ( ),                        
        .TXCRCPD                     (tied_to_vcc_i),                       
        .TXCRCRESET                  (tied_to_ground_i), 

         //-------------------------- Calibration Ports ------------------------   

        .RXCALFAIL                   ( ),                       
        .RXCYCLELIMIT                ( ),                    
        .TXCALFAIL                   ( ),                         
        .TXCYCLELIMIT                ( ),                     

        //---------------------------- Serial Ports ----------------------------   

        .RX1N                        (MGT1_RX1N_IN), 
        .RX1P                        (MGT1_RX1P_IN), 
        .TX1N                        (MGT1_TX1N_OUT), 
        .TX1P                        (MGT1_TX1P_OUT),


        //----------------------------- PLL Lock -------------------------------   

        .RXLOCK                      (mgt1_rxlock_i),
        .TXLOCK                      (mgt1_txlock_i),  


        //------------------------------ Resets --------------------------------  

        .RXPMARESET                  (mgt1_rxpmareset_i), 
        .RXRESET                     (MGT1_RXRESET_IN), 
        .TXPMARESET                  (mgt1_txpmareset_i), 
        .TXRESET                     (MGT1_TXRESET_IN), 

        //-------------------------- Synchronization ---------------------------   

        .RXSYNC                      (MGT1_RXSYNC_IN), 
        .TXSYNC                      (MGT1_TXSYNC_IN),    

        //-------------------------- Out of Band Signalling --------------------   

        .RXSIGDET                    (MGT1_RXSIGDET_OUT),                      
        .TXENOOB                     (MGT1_TXENOOB_IN), 
 
        //------------------------------ Status --------------------------------   

        .RXBUFERR                    ( ), 
        .RXCLKSTABLE                 (MGT1_RXCLKSTABLE_IN), 
        .RXSTATUS                    (MGT1_RXSTATUS_OUT), 
        .TXBUFERR                    ( ), 
        .TXCLKSTABLE                 (MGT1_TXCLKSTABLE_IN), 
  
        //-------------------------- Polarity Control Ports -------------------- 

        .RXPOLARITY                  (MGT1_RXPOLARITY_IN), 
        .TXINHIBIT                   (MGT1_TXINHIBIT_IN), 
        .TXPOLARITY                  (MGT1_TXPOLARITY_IN), 

        //----------------------------- Channel Bonding Ports ------------------   

        .CHBONDI                     (tied_to_ground_vec_i[4:0]), 
        .CHBONDO                     (mgt1_chbondo_i), 
        .ENCHANSYNC                  (tied_to_ground_i), 
 
        //-------------------------- 64B66B Blocks Use Ports -------------------   

        .RXBLOCKSYNC64B66BUSE        (tied_to_ground_i), 
        .RXDEC64B66BUSE              (tied_to_ground_i), 
        .RXDESCRAM64B66BUSE          (tied_to_ground_i), 
        .RXIGNOREBTF                 (tied_to_ground_i),   
        .TXENC64B66BUSE              (tied_to_ground_i), 
        .TXGEARBOX64B66BUSE          (tied_to_ground_i), 
        .TXSCRAM64B66BUSE            (tied_to_ground_i), 

        //-------------------------- 8B10B Blocks Use Ports --------------------   

        .RXDEC8B10BUSE               (tied_to_vcc_i), 
        .TXBYPASS8B10B               (mgt1_txbypass8b10b_i), 
        .TXENC8B10BUSE               (mgt1_txenc8b10buse_i), 

        //---------------------------- Transmit Control Ports ------------------   
        .TXCHARDISPMODE              ({tied_to_ground_vec_i[3:0],MGT1_TXCHARDISPMODE_IN[3:0]}), 
        .TXCHARDISPVAL               ({tied_to_ground_vec_i[3:0],MGT1_TXCHARDISPVAL_IN[3:0]}), 
        .TXCHARISK                   ({tied_to_ground_vec_i[3:0],MGT1_TXCHARISK_IN[3:0]}), 
        .TXKERR                      ({mgt1_txkerr_out_float_i[3:0],MGT1_TXKERR_OUT[3:0]}),                   
        .TXRUNDISP                   ({mgt1_txrundisp_out_float_i[3:0],MGT1_TXRUNDISP_OUT[3:0]}),                

        //---------------------------- Receive Control Ports -------------------   

        .RXCHARISCOMMA               ({mgt1_rxchariscomma_out_float_i[3:0],MGT1_RXCHARISCOMMA_OUT[3:0]}), 
        .RXCHARISK                   ({mgt1_rxcharisk_out_float_i[3:0],MGT1_RXCHARISK_OUT[3:0]}), 
        .RXDISPERR                   ({mgt1_rxdisperr_out_float_i[3:0],MGT1_RXDISPERR_OUT[3:0]}), 
        .RXNOTINTABLE                ({mgt1_rxnotintable_out_float_i[3:0],MGT1_RXNOTINTABLE_OUT[3:0]}), 
        .RXRUNDISP                   ({mgt1_rxrundisp_out_float_i[3:0],MGT1_RXRUNDISP_OUT[3:0]}),            

        //----------------------------- Serdes Alignment -----------------------  

        .ENMCOMMAALIGN               (MGT1_ENMCOMMAALIGN_IN), 
        .ENPCOMMAALIGN               (MGT1_ENPCOMMAALIGN_IN),
        .RXCOMMADET                  (MGT1_RXCOMMADET_OUT),                   
        .RXCOMMADETUSE               (tied_to_vcc_i), 
        .RXLOSSOFSYNC                ( ),           
        .RXREALIGN                   (MGT1_RXREALIGN_OUT), 
        .RXSLIDE                     (tied_to_ground_i), 

        //--------- Data Width Settings - Internal and fabric interface -------- 

        .RXDATAWIDTH                 (RXDATAWIDTH_P),        //parameter
        .RXINTDATAWIDTH              (RXINTDATAWIDTH_P),     //parameter 
        .TXDATAWIDTH                 (TXDATAWIDTH_P),        //parameter
        .TXINTDATAWIDTH              (TXINTDATAWIDTH_P),     //parameter 

        //----------------------------- Data Ports -----------------------------    

        .RXDATA                      ({mgt1_rxdata_out_float_i[31:0],MGT1_RXDATA_OUT[31:0]}), 
        .TXDATA                      ({tied_to_ground_vec_i[31:0],MGT1_TXDATA_IN[31:0]}), 

       //----------------------------- User Clocks -----------------------------   

        .RXMCLK                      ( ), 
        .RXPCSHCLKOUT                ( ), 
        .RXRECCLK1                   (MGT1_RXRECCLK1_OUT),     
        .RXRECCLK2                   (mgt1_rxrecclk2_i),     
        .RXUSRCLK                    (tied_to_ground_i), 
        .RXUSRCLK2                   (MGT1_RXUSRCLK2_IN), 
        .TXOUTCLK1                   (mgt1_txoutclk1_i), 
        .TXOUTCLK2                   (MGT1_TXOUTCLK2_OUT), 
        .TXPCSHCLKOUT                ( ),
        .TXUSRCLK                    (tied_to_ground_i), 
        .TXUSRCLK2                   (MGT1_TXUSRCLK2_IN), 


        //-------------------------- Reference Clocks --------------------------   

        .GREFCLK                     (tied_to_ground_i), 
        .REFCLK1                     (MGT1_REFCLK1_IN),        
        .REFCLK2                     (tied_to_ground_i), 

        //-------------------------- Powerdown and Loopback Ports --------------  

        .LOOPBACK                    (mgt1_loopback_i), 
        .POWERDOWN                   (MGT1_POWERDOWN_IN),

       //----------------- Dynamic Reconfiguration Port (DRP) ------------------
 
        .DADDR                       (mgt1_daddr_i),  
        .DCLK                        (MGT1_DCLK_IN), 
        .DEN                         (mgt1_den_i), 
        .DI                          (mgt1_di_i),    
        .DO                          (mgt1_do_i),                             
        .DRDY                        (mgt1_drdy_i),                            
        .DWE                         (mgt1_dwe_i), 

           //------------------- MGT Tile Communication Ports ------------------       

        .COMBUSIN                    (MGT1_COMBUSIN_IN), 
        .COMBUSOUT                   (MGT1_COMBUSOUT_OUT) 
    );


    //-------- RocketIO MGT 64B66B Block Sync State Machine Attributes --------- 

    defparam MGT1.SH_CNT_MAX              = 64;
    defparam MGT1.SH_INVALID_CNT_MAX      = 16;

    //--------------------- RocketIO MGT Alignment Atrributes ------------------   

    defparam MGT1.ALIGN_COMMA_WORD        = 4;
    defparam MGT1.COMMA_10B_MASK          = 10'h3ff;
    defparam MGT1.COMMA32                 = "FALSE";
    defparam MGT1.DEC_MCOMMA_DETECT       = "TRUE";
    defparam MGT1.DEC_PCOMMA_DETECT       = "TRUE";
    defparam MGT1.DEC_VALID_COMMA_ONLY    = "TRUE";
    defparam MGT1.MCOMMA_32B_VALUE        = 32'h0000017c;
    defparam MGT1.MCOMMA_DETECT           = "TRUE";
    defparam MGT1.PCOMMA_32B_VALUE        = 32'h00000283;
    defparam MGT1.PCOMMA_DETECT           = "TRUE";
    defparam MGT1.PCS_BIT_SLIP            = "FALSE";   

    //-- RocketIO MGT Atrributes Common to Clk Correction & Channel Bonding ----   

    defparam MGT1.CCCB_ARBITRATOR_DISABLE = "FALSE";
    defparam MGT1.CLK_COR_8B10B_DE        = "TRUE";    

    //----------------- RocketIO MGT Channel Bonding Atrributes ----------------   
    
    defparam MGT1.CHAN_BOND_LIMIT         = 16;
    defparam MGT1.CHAN_BOND_MODE          = "NONE";
    defparam MGT1.CHAN_BOND_ONE_SHOT      = "FALSE";
    defparam MGT1.CHAN_BOND_SEQ_1_1       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_1_2       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_1_3       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_1_4       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_1_MASK    = 4'b1110;
    defparam MGT1.CHAN_BOND_SEQ_2_1       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_2_2       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_2_3       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_2_4       = 11'b00000000000;
    defparam MGT1.CHAN_BOND_SEQ_2_MASK    = 4'b1111;
    defparam MGT1.CHAN_BOND_SEQ_2_USE     = "FALSE";
    defparam MGT1.CHAN_BOND_SEQ_LEN       = 1;    

    //---------------- RocketIO MGT Clock Correction Atrributes ----------------   

    defparam MGT1.CLK_COR_MAX_LAT         = 40;
    defparam MGT1.CLK_COR_MIN_LAT         = 28;
    defparam MGT1.CLK_COR_SEQ_1_1         = 11'b00101111100;
    defparam MGT1.CLK_COR_SEQ_1_2         = 11'b00010010101;
    defparam MGT1.CLK_COR_SEQ_1_3         = 11'b00010110101;
    defparam MGT1.CLK_COR_SEQ_1_4         = 11'b00010110101;
    defparam MGT1.CLK_COR_SEQ_1_MASK      = 4'b0000;
    defparam MGT1.CLK_COR_SEQ_2_1         = 11'b00110111100;
    defparam MGT1.CLK_COR_SEQ_2_2         = 11'b00001001010;
    defparam MGT1.CLK_COR_SEQ_2_3         = 11'b00001001010;
    defparam MGT1.CLK_COR_SEQ_2_4         = 11'b00001111011;
    defparam MGT1.CLK_COR_SEQ_2_MASK      = 4'b0000;
    defparam MGT1.CLK_COR_SEQ_2_USE       = "TRUE";
    defparam MGT1.CLK_COR_SEQ_DROP        = "FALSE";
    defparam MGT1.CLK_COR_SEQ_LEN         = 4;
    defparam MGT1.CLK_CORRECT_USE         = "FALSE";    
    
    //-------------------- RocketIO MGT Clocking Atrributes --------------------      

    defparam MGT1.RX_CLOCK_DIVIDER        = 2'b11;
    defparam MGT1.RXASYNCDIVIDE           = 2'b10;
    defparam MGT1.RXCLK0_FORCE_PMACLK     = "FALSE";
    defparam MGT1.RXCLKMODE               = 6'b000011;
    defparam MGT1.RXOUTDIV2SEL            = 4;
    defparam MGT1.RXPLLNDIVSEL            = 20;
    defparam MGT1.RXPMACLKSEL             = "REFCLK1";
    defparam MGT1.RXRECCLK1_USE_SYNC      = "FALSE";
    defparam MGT1.RXUSRDIVISOR            = 1;
    defparam MGT1.TX_CLOCK_DIVIDER        = 2'b11;
    defparam MGT1.TXABPMACLKSEL           = "REFCLK1";
    defparam MGT1.TXASYNCDIVIDE           = 2'b10;
    defparam MGT1.TXCLK0_FORCE_PMACLK     = "FALSE";
    defparam MGT1.TXCLKMODE               = 4'b0100;
    defparam MGT1.TXOUTCLK1_USE_SYNC      = "FALSE";
    defparam MGT1.TXOUTDIV2SEL            = 4;
    defparam MGT1.TXPHASESEL              = "TRUE"; 
    defparam MGT1.TXPLLNDIVSEL            = 20;

    //------------------------ RocketIO MGT CRC Atrributes ---------------------   

    defparam MGT1.RXCRCCLOCKDOUBLE        = "FALSE";
    defparam MGT1.RXCRCENABLE             = "FALSE";
    defparam MGT1.RXCRCINITVAL            = 32'h00000000;
    defparam MGT1.RXCRCINVERTGEN          = "FALSE";
    defparam MGT1.RXCRCSAMECLOCK          = "TRUE";
    defparam MGT1.TXCRCCLOCKDOUBLE        = "FALSE";
    defparam MGT1.TXCRCENABLE             = "FALSE";
    defparam MGT1.TXCRCINITVAL            = 32'h00000000;
    defparam MGT1.TXCRCINVERTGEN          = "FALSE";
    defparam MGT1.TXCRCSAMECLOCK          = "TRUE";
        
    //------------------- RocketIO MGT Data Path Atrributes --------------------   

    defparam MGT1.RXDATA_SEL              = 2'b11;
    defparam MGT1.TXDATA_SEL              = 2'b10;

    //-------------- RocketIO MGT Digital Receiver Attributes ------------------   

    defparam MGT1.DIGRX_FWDCLK            = 2'b00;
    defparam MGT1.DIGRX_SYNC_MODE         = "TRUE";
    defparam MGT1.ENABLE_DCDR             = "FALSE";
    defparam MGT1.RXBY_32                 = "FALSE";
    defparam MGT1.RXDIGRESET              = "FALSE";
    defparam MGT1.RXDIGRX                 = "FALSE";
    defparam MGT1.SAMPLE_8X               = "FALSE";

    //--------------- Rocket IO MGT Miscellaneous Attributes ------------------     

    defparam MGT1.GT11_MODE               = MGT1_GT11_MODE_P;
    defparam MGT1.OPPOSITE_SELECT         = "FALSE";
    defparam MGT1.PMA_BIT_SLIP            = "FALSE";
    defparam MGT1.REPEATER                = "FALSE";
    defparam MGT1.RX_BUFFER_USE           = "FALSE";
    defparam MGT1.RXCDRLOS                = 6'b000000;
    defparam MGT1.RXDCCOUPLE              = "FALSE";
    defparam MGT1.RXFDCAL_CLOCK_DIVIDE    = "NONE";
    defparam MGT1.TX_BUFFER_USE           = "FALSE";     
    defparam MGT1.TXFDCAL_CLOCK_DIVIDE    = "NONE";
    defparam MGT1.TXSLEWRATE              = "TRUE";

    //--------------- Rocket IO MGT Preemphasis and Equalization --------------
    
    defparam MGT1.RXAFEEQ                  = 9'b000000000;
    defparam MGT1.RXEQ                     = 64'h4000000000000000;
    defparam MGT1.TXDAT_PRDRV_DAC          = 3'b111;
    defparam MGT1.TXDAT_TAP_DAC            = 5'b10110;    
    defparam MGT1.TXHIGHSIGNALEN           = "TRUE";
    defparam MGT1.TXPOST_PRDRV_DAC         = 3'b111;
    defparam MGT1.TXPOST_TAP_DAC           = 5'b00001;
    defparam MGT1.TXPOST_TAP_PD            = "TRUE";
    defparam MGT1.TXPRE_PRDRV_DAC          = 3'b111;
    defparam MGT1.TXPRE_TAP_DAC            = 5'b00000;
    defparam MGT1.TXPRE_TAP_PD             = "TRUE";           
    

    //--------------------- Restricted RocketIO MGT Attributes -------------------  

    ///Note : THE FOLLOWING ATTRIBUTES ARE RESTRICTED. PLEASE DO NOT EDIT.

    //--------------------------- Restricted: Biasing -------------------------
    
    defparam MGT1.BANDGAPSEL               = "FALSE";
    defparam MGT1.BIASRESSEL               = "FALSE";    
    defparam MGT1.IREFBIASMODE             = 2'b11;
    defparam MGT1.PMAIREFTRIM              = 4'b0111;
    defparam MGT1.PMAVREFTRIM              = 4'b0111;
    defparam MGT1.TXAREFBIASSEL            = "TRUE"; 
    defparam MGT1.TXTERMTRIM               = 4'b1100;
    defparam MGT1.VREFBIASMODE             = 2'b11;

    //-------------- Restricted: Frequency Detector and Calibration -----------   
     
    defparam MGT1.CYCLE_LIMIT_SEL          = 2'b00;
    defparam MGT1.FDET_HYS_CAL             = 3'b010;
    defparam MGT1.FDET_HYS_SEL             = 3'b100;
    defparam MGT1.FDET_LCK_CAL             = 3'b101;
    defparam MGT1.FDET_LCK_SEL             = 3'b001;
    defparam MGT1.LOOPCAL_WAIT             = 2'b00;
    defparam MGT1.RXCYCLE_LIMIT_SEL        = 2'b00;
    defparam MGT1.RXFDET_HYS_CAL           = 3'b010;
    defparam MGT1.RXFDET_HYS_SEL           = 3'b100;
    defparam MGT1.RXFDET_LCK_CAL           = 3'b101;   
    defparam MGT1.RXFDET_LCK_SEL           = 3'b001;
    defparam MGT1.RXLOOPCAL_WAIT           = 2'b00;
    defparam MGT1.RXSLOWDOWN_CAL           = 2'b00;
    defparam MGT1.SLOWDOWN_CAL             = 2'b00;
    
    //------------------------- Restricted: PLL Settings ----------------------
    
    defparam MGT1.PMACLKENABLE             = "TRUE";
    defparam MGT1.PMACOREPWRENABLE         = "TRUE";
    defparam MGT1.PMAVBGCTRL               = 5'b00000;
    defparam MGT1.RXACTST                  = "FALSE";       
    defparam MGT1.RXAFETST                 = "FALSE";      
    defparam MGT1.RXCMADJ                  = 2'b01;
    defparam MGT1.RXCPSEL                  = "FALSE";
    defparam MGT1.RXCPTST                  = "FALSE";
    defparam MGT1.RXCTRL1                  = 10'h200;
    defparam MGT1.RXFECONTROL1             = 2'b00; 
    defparam MGT1.RXFECONTROL2             = 3'b000; 
    defparam MGT1.RXFETUNE                 = 2'b01; 
    defparam MGT1.RXLKADJ                  = 5'b00000;
    defparam MGT1.RXLOOPFILT               = 4'b1111;
    defparam MGT1.RXPDDTST                 = "TRUE";      
    defparam MGT1.RXRCPADJ                 = 3'b011; 
    defparam MGT1.RXRIBADJ                 = 2'b11;
    defparam MGT1.RXVCO_CTRL_ENABLE        = "TRUE";
    defparam MGT1.RXVCODAC_INIT            = 10'b0000101001;   
    defparam MGT1.TXCPSEL                  = "FALSE";
    defparam MGT1.TXCTRL1                  = 10'h200;
    defparam MGT1.TXLOOPFILT               = 4'b1101;   
    defparam MGT1.VCO_CTRL_ENABLE          = "TRUE";
    defparam MGT1.VCODAC_INIT              = 10'b0000101001;
    
    //------------------------- Restricted: Powerdowns ------------------------
     
    defparam MGT1.POWER_ENABLE             = "TRUE";
    defparam MGT1.RXAFEPD                  = "FALSE";
    defparam MGT1.RXAPD                    = "FALSE";
    defparam MGT1.RXLKAPD                  = "FALSE";
    defparam MGT1.RXPD                     = "FALSE";
    defparam MGT1.RXRCPPD                  = "FALSE";
    defparam MGT1.RXRPDPD                  = "FALSE";
    defparam MGT1.RXRSDPD                  = "FALSE";
    defparam MGT1.TXAPD                    = "FALSE";
    defparam MGT1.TXDIGPD                  = "FALSE";
    defparam MGT1.TXLVLSHFTPD              = "FALSE";
    defparam MGT1.TXPD                     = "FALSE";





    //----------------------------- Calibration Block --------------------------




    // Some signals are intercepted by different versions of the calblock. Here, we simply connect them
    assign  mgt1_rxpmareset_i    =   MGT1_RXPMARESET_IN;
    assign  MGT1_RXLOCK_OUT   =   mgt1_rxlock_i;
    assign  MGT1_TXLOCK_OUT   =   mgt1_txlock_i;
    assign  mgt1_txpmareset_i    =   MGT1_TXPMARESET_IN;    
    assign  MGT1_RXRECCLK2_OUT   =   mgt1_rxrecclk2_i;
    assign  MGT1_TXOUTCLK1_OUT   =   mgt1_txoutclk1_i;



    cal_block_v1_4_1 #
    (
      .C_MGT_ID           (MGT1_MGT_ID_P),                        // 0 = MGTA | 1 = MGTB 
      .C_TXPOST_TAP_PD    ("TRUE"),                   // Default POST TAP PD
      .C_RXDIGRX          ("FALSE")                          // Default RXDIGRX
    ) 
    MGT1_CAL_BLOCK
    (
      // User DRP Interface (destination/slave interface)
      .USER_DO            (MGT1_DO_OUT),
      .USER_DI            (MGT1_DI_IN),
      .USER_DADDR         (MGT1_DADDR_IN),
      .USER_DEN           (MGT1_DEN_IN),
      .USER_DWE           (MGT1_DWE_IN),
      .USER_DRDY          (MGT1_DRDY_OUT),
    
      // MGT DRP Interface (source/master interface)
      .GT_DO              (mgt1_di_i),
      .GT_DI              (mgt1_do_i),
      .GT_DADDR           (mgt1_daddr_i),
      .GT_DEN             (mgt1_den_i),
      .GT_DWE             (mgt1_dwe_i),
      .GT_DRDY            (mgt1_drdy_i),
    
      // Calibration Block Active and Disable Signals 
      .ACTIVE             (MGT1_ACTIVE_OUT),
        
      // User side MGT Pass through Signals
      .USER_LOOPBACK      (MGT1_LOOPBACK_IN),
      .USER_TXENC8B10BUSE (tied_to_vcc_i),
      .USER_TXBYPASS8B10B ({tied_to_ground_vec_i[3:0],MGT1_TXBYPASS8B10B_IN[3:0]}), 

      // GT side MGT Pass through Signals
      .GT_LOOPBACK        (mgt1_loopback_i),
      .GT_TXENC8B10BUSE   (mgt1_txenc8b10buse_i),
      .GT_TXBYPASS8B10B   (mgt1_txbypass8b10b_i),

      // Signal Detect Ports
      .TX_SIGNAL_DETECT   (MGT1_TX_SIGNAL_DETECT_IN),
      .RX_SIGNAL_DETECT   (MGT1_RX_SIGNAL_DETECT_IN),

      // Clock and Reset
      .DCLK               (MGT1_DCLK_IN),
      .RESET              (MGT1_DRP_RESET_IN)
    );

     
    
  




endmodule

