
///////////////////////////////////////////////////////////////////////////////
//$Date: 2010/06/25 15:58:01 $
//$RCSfile: example_tb.ejava,v $
//$Revision: 1.2 $
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.7
//  \   \         Application : RocketIO Wizard 
//  /   /         Filename : example_tb.v
// /___/   /\     Timestamp : 
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module EXAMPLE_TB
// Generated by Xilinx RocketIO Wizard

//  ***************************************************************************
// (c) Copyright 2006 - 2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.

//  ***************************************************************************


`timescale 1ns / 1ps

module EXAMPLE_TB;

//*************************Parameter Declarations**************************

    parameter   UPPER_REFCLK_PERIOD         =   6.67;
    parameter   DRP_CLOCK_PERIOD            =   20.0;

  
//************************Internal Register Declarations*****************************

//************************** Register Declarations ****************************        

    reg     [0:3]      debounce_pma_reset_r;
    reg                drp_clk_r;
    reg                tx_usrclk_r;
    reg                rx_usrclk_r;
    reg                upper_refclk_n_r;
    
    reg                gsr_r;
    reg                gts_r;
    reg                reset_i;
    

//********************************Wire Declarations**********************************

    //--------------------------------- Global Signals ------------------------------

    wire                upper_refclk_p_r;
    

    //-------------------------- Example Module Connections -------------------------

    wire    [1:0]       rx1n_in_i;
    wire    [1:0]       rx1p_in_i;
    wire    [1:0]       tx1n_out_i;
    wire    [1:0]       tx1p_out_i;
    wire    [7:0]       mgt0_error_count_i;
    wire    [7:0]       mgt1_error_count_i;
    wire                mgt0_rxlock_i;
    wire                mgt0_txlock_i;
    wire                mgt0_rx1n_i;
    wire                mgt0_rx1p_i;
    wire                mgt0_tx1n_i;
    wire                mgt0_tx1p_i;
    wire                mgt1_rxlock_i;
    wire                mgt1_txlock_i;
    wire                mgt1_rx1n_i;
    wire                mgt1_rx1p_i;
    wire                mgt1_tx1n_i;
    wire                mgt1_tx1p_i;
    

//*********************************Main Body of Code**********************************


    // ------------------------------- Tie offs -------------------------------- 
    
    assign  tied_to_ground_i     =    1'b0;
    
    // ------------------------- MGT Serial Connections ------------------------

    assign   rx1n_in_i           =  tx1n_out_i;
    assign   rx1p_in_i           =  tx1p_out_i;
   
    //------------------------------ Global Signals ----------------------------
    
    //Simultate the global reset that occurs after configuration at the beginning
    //of the simulation. 
    assign glbl.GSR = gsr_r;
    assign glbl.GTS = gts_r;

    initial
        begin
            gts_r = 1'b0;        
            gsr_r = 1'b1;
            #(16*UPPER_REFCLK_PERIOD);
            gsr_r = 1'b0;
    end
 


    //---------- Generate Reference Clock input to UPPER MGTCLK ----------------
    
    initial begin
        upper_refclk_n_r = 1'b1;
    end

    always  
        #(UPPER_REFCLK_PERIOD/2) upper_refclk_n_r = !upper_refclk_n_r;

    assign upper_refclk_p_r = !upper_refclk_n_r;
                
 

    
    //------------------------ Generate DRP Clock ----------------------------
    
    initial begin
        drp_clk_r = 1'b1;
    end

    always  
        #(DRP_CLOCK_PERIOD/2) drp_clk_r = !drp_clk_r;
    
        
    
    //--------------------------------- Resets ---------------------------------
    
    initial
    begin
        reset_i = 1'b1;
        #100 reset_i = 1'b0;
    end

    //----------------- Instantiate an EXAMPLE_MGT_TOP module  -----------------

    EXAMPLE_MGT_TOP #
    (
        .SIMULATION_P                   (1),//1 - set to 1 for simulation  
        .USE_CHIPSCOPE                  (0) //1 - use chipscope to drive resets                                           //0-drive resets from top level ports
    )
    example_mgt_top_i
    (
        .UPPER_MGTCLK_PAD_N_IN          (upper_refclk_n_r),
        .UPPER_MGTCLK_PAD_P_IN          (upper_refclk_p_r),
        .DRP_CLK_IN                     (drp_clk_r),
        .TX_SYSTEM_RESET_IN             (reset_i),
        .RX_SYSTEM_RESET_IN             (reset_i),
        .MGT0_RXLOCK_OUT                (mgt0_rxlock_i),
        .MGT0_TXLOCK_OUT                (mgt0_txlock_i),
        .MGT1_RXLOCK_OUT                (mgt1_rxlock_i),
        .MGT1_TXLOCK_OUT                (mgt1_txlock_i),
        .RX1N_IN                        (rx1n_in_i),
        .RX1P_IN                        (rx1p_in_i),
        .TX1N_OUT                       (tx1n_out_i),
        .TX1P_OUT                       (tx1p_out_i)
    );


endmodule

